VERSION 5.00
Begin VB.Form frmBMP 
   Appearance      =   0  'Flat
   BackColor       =   &H80000004&
   Caption         =   "Form"
   ClientHeight    =   5355
   ClientLeft      =   1170
   ClientTop       =   1695
   ClientWidth     =   6645
   ForeColor       =   &H80000008&
   Icon            =   "FRMBMP.frx":0000
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   5355
   ScaleWidth      =   6645
   WindowState     =   1  'Minimized
   Begin VB.CommandButton Command4 
      Appearance      =   0  'Flat
      Caption         =   "&Font"
      Height          =   285
      Left            =   2400
      TabIndex        =   6
      Top             =   4680
      Visible         =   0   'False
      Width           =   1200
   End
   Begin VB.PictureBox Picture1 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000004&
      FillColor       =   &H00C0C0C0&
      FillStyle       =   0  'Solid
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   238
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H80000008&
      Height          =   255
      Left            =   6360
      ScaleHeight     =   225
      ScaleWidth      =   225
      TabIndex        =   5
      Top             =   5160
      Width           =   255
   End
   Begin VB.HScrollBar HScroll1 
      Height          =   255
      LargeChange     =   50
      Left            =   0
      SmallChange     =   15
      TabIndex        =   2
      Top             =   5160
      Width           =   6375
   End
   Begin VB.VScrollBar VScroll1 
      Height          =   4815
      LargeChange     =   50
      Left            =   6360
      SmallChange     =   15
      TabIndex        =   1
      Top             =   0
      Width           =   255
   End
   Begin VB.PictureBox Bmp 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      ClipControls    =   0   'False
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   238
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H80000008&
      Height          =   4095
      Left            =   0
      ScaleHeight     =   4065
      ScaleWidth      =   6345
      TabIndex        =   0
      Top             =   0
      Width           =   6375
   End
   Begin VB.Label YBmp 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   238
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H80000008&
      Height          =   255
      Left            =   1320
      TabIndex        =   4
      Top             =   4560
      Visible         =   0   'False
      Width           =   735
   End
   Begin VB.Label XBmp 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   238
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H80000008&
      Height          =   255
      Left            =   120
      TabIndex        =   3
      Top             =   4560
      Visible         =   0   'False
      Width           =   975
   End
End
Attribute VB_Name = "frmBMP"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Public Index As Integer
Public TypeOfForm As String

Public Sub BitmapClip()
If gAnaliza = 1 Then
  Beep
  Exit Sub
End If

On Error GoTo KopyErr
Screen.MousePointer = vbHourglass ' display hourglass
Clipboard.Clear
Clipboard.SetData Bmp.Image 'format?
Screen.MousePointer = vbDefault

Exit Sub

KopyErr:
  Screen.MousePointer = vbDefault
  MsgBox "Clipboard error!" & vbCrLf & Err.Description, 0 + 16
  Exit Sub

End Sub

Public Sub SaveBMP(strFile As String)
If gAnaliza = 1 Then
   Beep
   Exit Sub
End If
 
'Dim strFile As String
Dim DIB As Long
Dim DIB_grey As Long

If strFile = "" Then
   strFile = ShowSave(frmMDI.hwnd, _
           "BMP (*.bmp)" + Chr$(0) + "*.bmp" + Chr$(0) + _
           "TIFF (*.tif)" + Chr$(0) + "*.tif" + Chr$(0) + _
           "PNG (*.png)" + Chr$(0) + "*.png" + Chr$(0) _
          , App.Title + " - Save bitmap As", "*.bmp")
End If

If strFile = "" Then Exit Sub
strFile = LCase$(strFile)

Screen.MousePointer = vbHourglass ' display hourglass

Bmp.Picture = Bmp.Image
'MsgBox CStr(Bmp.Picture.Width) & "/" & CStr(Bmp.Picture.Height)
FreeImage_Initialise

If FreeImage_DIB_From_BMP(Bmp.Image, DIB) = True Then
    DIB_grey = FreeImage_ConvertTo8Bits(DIB)
    Select Case LCase$(Right$(strFile, 4))
        Case ".bmp"
            FreeImage_SaveBMP DIB_grey, strFile
        Case ".tif"
            FreeImage_SaveTIFF DIB_grey, strFile
        Case ".png"
            FreeImage_SavePNG DIB_grey, strFile
    End Select
    FreeImage_Unload DIB
    FreeImage_Unload DIB_grey
Else
  MsgBox "Error: FreeImage_DIB_From_BMP", vbCritical, "Save bitmap"
End If

FreeImage_DeInitialise

Screen.MousePointer = vbDefault

frmMDI.ActiveForm.Caption = "[BITMAP]: " & strFile
 
End Sub


Private Sub Command4_Click()
'frmFont.Show 1
End Sub

Private Sub Form_Activate()
frmMDI.toolMain.Buttons("MakeMatrix").Enabled = False
frmMDI.toolMain.Buttons("MakeDiagram").Enabled = False
frmMDI.toolMain.Buttons("Save").Enabled = True
frmMDI.toolMain.Buttons("SaveAs").Enabled = True
frmMDI.toolMain.Buttons("Print").Enabled = False
frmMDI.toolBitmap.Visible = True

'menu export
frmMDI.mnuExport.Enabled = False
frmMDI.mnuExportText.Enabled = False
frmMDI.mnuExportExcel.Enabled = False
frmMDI.mnuExportBitmap.Enabled = False
frmMDI.mnuExportMeta.Enabled = False

frmMDI.mnuSave.Enabled = True
frmMDI.mnuSaveAs.Enabled = True

frmMDI.mnuEditCopyClip.Enabled = True

TypeOfForm = "BITMAP"
End Sub

Private Sub Form_Deactivate()
frmMDI.toolMain.Buttons("MakeMatrix").Enabled = True
frmMDI.toolMain.Buttons("MakeDiagram").Enabled = True
frmMDI.toolMain.Buttons("Save").Enabled = False
frmMDI.toolMain.Buttons("SaveAs").Enabled = False
frmMDI.toolMain.Buttons("Print").Enabled = False
frmMDI.toolBitmap.Visible = False

frmMDI.mnuSave.Enabled = False
frmMDI.mnuSaveAs.Enabled = False

frmMDI.mnuEditCopyClip.Enabled = False
End Sub

Private Sub Form_Load()
Index = gIndex
End Sub

Private Sub Form_Resize()
If WindowState <> 1 And ScaleHeight <> 0 Then
  Bmp.Top = 0
  Bmp.Left = 0
  Bmp.Width = ScaleWidth - VScroll1.Width
    
  Bmp.Height = Val(YBmp.Caption)
  Bmp.Width = Val(XBmp.Caption)
  VScroll1.value = 0
  HScroll1.value = 0
    
  VScroll1.Height = ScaleHeight - HScroll1.Height
  HScroll1.Width = ScaleWidth - VScroll1.Width
  VScroll1.Max = Val(YBmp.Caption) - (ScaleHeight - HScroll1.Height)
  If VScroll1.Max < 0 Then VScroll1.Max = 0
  VScroll1.Left = ScaleWidth - VScroll1.Width
  VScroll1.Top = 0

  HScroll1.Max = Val(XBmp.Caption) - (ScaleWidth - VScroll1.Width)
  If HScroll1.Max < 0 Then HScroll1.Max = 0
  HScroll1.Top = ScaleHeight - HScroll1.Height
  HScroll1.Left = 0
    
  Picture1.Top = VScroll1.Height
  Picture1.Left = HScroll1.Width
End If

End Sub

Private Sub Form_Unload(Cancel As Integer)
frmMDI.toolBitmap.Visible = False
frmMDI.toolMain.Buttons("MakeMatrix").Enabled = False
frmMDI.toolMain.Buttons("MakeDiagram").Enabled = False
frmMDI.toolMain.Buttons("Save").Enabled = False
frmMDI.toolMain.Buttons("SaveAs").Enabled = False
frmMDI.toolMain.Buttons("Print").Enabled = False
End Sub

Private Sub HScroll1_Change()
Bmp.Left = 0 - HScroll1.value
End Sub

Private Sub VScroll1_Change()
Bmp.Top = 0 - VScroll1.value
End Sub

