Attribute VB_Name = "modStatMath"
Option Explicit

Public gFindString, gFindCase As Integer, gFindDirection As Integer
Public gCurPos As Integer, gFirstTime As Integer
Public ArrayNum As Integer

'Deklaracja API do wywolywania pliku pomocy
Declare Function OSWinHelp% Lib "user32" Alias "WinHelpA" (ByVal hwnd&, ByVal HelpFile$, ByVal wCommand%, dwData As Any)

Public GoNew As Integer
Public Katalog As String
Public Zmiana As Boolean, Kasowanie As Integer
Public LiczbaZmiennych As Integer, LiczbaRekordow As Integer
Public RecInfo() As String
Public DaneMaczka() As Single
Public Dystans() As Single
Public Etykiety() As String
Public Przedzial() As Single
Public RodzajDiagramu As Integer, DystansType As Integer, OrderType As Integer
Public Dalej As Integer, Przekaznik As Integer, Przekaznik2 As Integer
Public Decyzja As Integer, WielkoscDiagramu As Integer
Public CommaType As Integer, ECommaType As Integer, InsertVariable As Integer
Public NumberNew As Integer
Public Par_P As Integer, Par_R As Integer
Public ImportFile As String
Public NumerFontu As Integer, RecName As Integer, VarName As Integer
Public fStop As Boolean
Public MaxMutacja As Integer, NumberChromo As Integer
Public SequenceChange As Integer, FragmentTransfer As Integer
Public SomeSingleTransfers As Integer, SingleTransfers As Integer, SomeRemoteConversions As Integer
Public RemoteConversion As Integer, SomeNeighbourConversion As Integer, NeighbourConversion As Integer
Public Mutation As Integer, Generation As Integer, MatrixCC As Single
Public Probablity As Long

Public Const HWND_TOPMOST = -1
Public Const HWND_NOTOPMOST = -2
Public Const SWP_NOSIZE = &H1
Public Const SWP_NOMOVE = &H2
Public Const SWP_NOACTIVATE = &H10
Public Const SWP_SHOWWINDOW = &H40
Private Declare Sub SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long)
' stara deklaracja: Declare Function SetWindowPos Lib "User32" (ByVal h%, ByVal hb%, ByVal X%, ByVal Y%, ByVal cx%, ByVal cy%, ByVal F%) As Integer
' The above Declare statement must appear on one line.

Rem To set the form XXXX to TOPMOST, use the following code:
Rem To reset the form XXXX to NON-TOPMOST, use the following code:
Rem success% = SetWindowPos (XXXX.hWnd, HWND_NOTOPMOST, 0, 0, 0, 0, FLAGS)
Rem success% <> 0 When Successful

Public gAnaliza As Integer, gHistogram As Integer
Public TypStandard As Integer
Public Const ThisApp = "MaCzek"        ' Registry App constant.
Public Const ThisKey = "Recent Files"   ' Registry Key constant.
Public gIndex As Integer   'index okna z diagramem
Public gMaxObject As Integer
Public gAutoCalcul As Boolean
Public gArkuszHeight As Long
Public gFromMatrix As Boolean
Public gDataNA As Boolean ' czy dane niepene?
Public Const gEmpty = -9999999 'staa oznaczajca brak danych
Public gDataRecNA() As Boolean

Sub AddRecord()
If gAnaliza = 1 Then
   Beep
   Exit Sub
End If

Dim i As Integer
If frmMDI.ActiveForm.Grid1.Rows - 1 = 150 Then
   Beep
   MsgBox "Max. 150 records!"
   Exit Sub
End If

NumberNew = 0
' Call CenterForm(frmMDI, frmAddRec)
frmAddRec.Show 1
If Dalej = -99 Then Exit Sub

For i = 1 To NumberNew
   frmMDI.ActiveForm.Grid1.Rows = frmMDI.ActiveForm.Grid1.Rows + 1
   frmMDI.ActiveForm.Grid1.Row = frmMDI.ActiveForm.Grid1.Rows - 1
   frmMDI.ActiveForm.Grid1.Col = 0
   frmMDI.ActiveForm.Grid1.Text = Str$(frmMDI.ActiveForm.Grid1.Rows - 1)
   frmMDI.ActiveForm.Grid1.Row = frmMDI.ActiveForm.Grid1.Rows - 1
Next
FState(frmMDI.ActiveForm.Tag).Dirty = True
End Sub

Sub AddVariable()
If gAnaliza = 1 Then
 Beep
 Exit Sub
End If

Dim i As Integer
 If frmMDI.ActiveForm.Grid1.Cols - 2 = 100 Then
  Beep
  MsgBox "You cannot define more than 100 variables in a data sheet!", 0 + 16
  Exit Sub
 End If

 NumberNew = 0
' Call CenterForm(frmMDI, frmAddVar)
 frmAddVar.Show 1
 If Dalej = -99 Then Exit Sub

For i = 1 To NumberNew
 frmMDI.ActiveForm.Grid1.Cols = frmMDI.ActiveForm.Grid1.Cols + 1
 frmMDI.ActiveForm.Grid1.Col = frmMDI.ActiveForm.Grid1.Cols - 1
 frmMDI.ActiveForm.Grid1.Row = 0
 frmMDI.ActiveForm.Grid1.Text = "VAR" + Str$(frmMDI.ActiveForm.Grid1.Cols - 2)
 frmMDI.ActiveForm.Grid1.COLWIDTH(frmMDI.ActiveForm.Grid1.Cols - 1) = frmMDI.ActiveForm.Grid1.COLWIDTH(frmMDI.ActiveForm.Grid1.Cols - 2)
 frmMDI.ActiveForm.Grid1.ColAlignment(frmMDI.ActiveForm.Grid1.Cols - 1) = 2
 frmMDI.ActiveForm.Grid1.FixedAlignment(frmMDI.ActiveForm.Grid1.Cols - 1) = 2
Next

 FState(frmMDI.ActiveForm.Tag).Dirty = True

End Sub

Function AnyPadsLeft() As Integer
    Dim i As Integer

    ' Cycle throught the document array.
    ' Return True if there is at least one
    ' open document remaining.
    For i = 1 To UBound(document)
        If Not FState(i).Deleted Then
            AnyPadsLeft = True
            Exit Function
        End If
    Next

End Function

Sub CheckData()
If gAnaliza = 1 Then
   Beep
   Exit Sub
End If

'wczytanie danych z arkusza
Dim ArkuszWidth As Long, ArkuszHeight As Long
Dim i, j, k As Integer
Dim PrzekaznikOpis
Dim Konwersja, ZmiennaKonwersji, Litera

frmMDI.ActiveForm.Grid1.SetFocus
Err = 0 ' zerowanie bdw

ArkuszWidth = frmMDI.ActiveForm.Grid1.Cols - 2
ArkuszHeight = frmMDI.ActiveForm.Grid1.Rows - 1

If ArkuszHeight < 1 Then
   MsgBox "Empty data", 0 + 16
   Exit Sub
End If

Screen.MousePointer = vbHourglass

frmMDI.ActiveForm.Grid1.SetFocus
frmMDI.ActiveForm.Grid1.Col = 2
frmMDI.ActiveForm.Grid1.Row = 1

ReDim RecInfo(1 To ArkuszHeight)
ReDim DaneMaczka(1 To ArkuszHeight, 1 To ArkuszWidth)
ReDim Etykiety(1 To ArkuszWidth)
ReDim Dys_S(1 To ArkuszHeight)
ReDim Dys_P(1 To ArkuszHeight)
ReDim Grupa(1 To ArkuszHeight, 1 To ArkuszHeight)

PrzekaznikOpis = frmMDI.ActiveForm.OpisText

'wczytanie nazw rekordw
frmMDI.ActiveForm.Grid1.Col = 1
For i = 1 To ArkuszHeight
   frmMDI.ActiveForm.Grid1.Row = i
   RecInfo(i) = LTrim$(RTrim$(frmMDI.ActiveForm.Grid1.Text))
Next

'wczytanie nazw etykiet
frmMDI.ActiveForm.Grid1.Row = 0
For i = 2 To ArkuszWidth + 1
   frmMDI.ActiveForm.Grid1.Col = i
   Etykiety(i - 1) = LTrim$(RTrim$(frmMDI.ActiveForm.Grid1.Text))
Next

Dim Puste As Integer

'wczytanie danych
For i = 1 To ArkuszHeight
 frmMDI.ActiveForm.Grid1.Row = i
 For j = 1 To ArkuszWidth
  frmMDI.ActiveForm.Grid1.Col = j + 1

  'konwersja danych jeli system Windows ma ustawiony separator jako przecinek
     Konwersja = frmMDI.ActiveForm.Grid1.Text
     ZmiennaKonwersji = ""
     For k = 1 To Len(Konwersja)
      Litera = Mid$(Konwersja, k, 1)
      If Litera = "," Then Litera = "."
      ZmiennaKonwersji = ZmiennaKonwersji + Litera
     Next
     Konwersja = ZmiennaKonwersji
   DaneMaczka(i, j) = Val(LTrim$(RTrim$(Konwersja)))

  If Err Then
   MsgBox "Data Error. Row=" + Str$(i) + ", Col=" + Str$(j), 0 + 16
   Screen.MousePointer = 0
   Exit Sub
  End If
  If LTrim$(RTrim$(frmMDI.ActiveForm.Grid1.Text)) = "" Then
   frmMDI.ActiveForm.Grid1.Text = "0.0"
  End If
  If DaneMaczka(i, j) = 0 Then
   Puste = Puste + 1
  End If
 Next
Next

Screen.MousePointer = vbDefault

If Puste = 0 Then
   MsgBox "No empty (or zero) cells in data!"
ElseIf Puste = 1 Then
   MsgBox LTrim$(Str$(Puste)) + " empty (or zero) cell is found"
ElseIf Puste > 1 Then
   MsgBox LTrim$(Str$(Puste)) + " empty (or zero) cells are found"
End If

End Sub

Sub Decriptive()
If gAnaliza = 1 Then
   Beep
   Exit Sub
End If

'wczytanie danych z arkusza
Dim ArkuszWidth As Long, ArkuszHeight As Long
Dim i As Integer, j As Integer, k As Integer
Dim PrzekaznikOpis

frmMDI.ActiveForm.Grid1.SetFocus
ArkuszWidth = frmMDI.ActiveForm.Grid1.Cols - 2
ArkuszHeight = frmMDI.ActiveForm.Grid1.Rows - 1

If ArkuszHeight < 2 Then
 MsgBox "The number of records is less than 2. How make standarization?", 0 + 16
 Exit Sub
End If

Screen.MousePointer = vbHourglass
Err = 0 ' zerowanie bdw

frmMDI.ActiveForm.Grid1.SetFocus
frmMDI.ActiveForm.Grid1.Col = 2
frmMDI.ActiveForm.Grid1.Row = 1

ReDim RecInfo(1 To ArkuszHeight)
ReDim DaneMaczka(1 To ArkuszHeight, 1 To ArkuszWidth)
ReDim Etykiety(1 To ArkuszWidth)
ReDim Dys_S(1 To ArkuszHeight)
ReDim Dys_P(1 To ArkuszHeight)
ReDim Grupa(1 To ArkuszHeight, 1 To ArkuszHeight)

PrzekaznikOpis = frmMDI.ActiveForm.OpisText

'wczytanie nazw rekordw
frmMDI.ActiveForm.Grid1.Col = 1
For i = 1 To ArkuszHeight
   frmMDI.ActiveForm.Grid1.Row = i
   RecInfo(i) = LTrim$(RTrim$(frmMDI.ActiveForm.Grid1.Text))
Next

'wczytanie nazw etykiet
frmMDI.ActiveForm.Grid1.Row = 0
For i = 2 To ArkuszWidth + 1
   frmMDI.ActiveForm.Grid1.Col = i
   Etykiety(i - 1) = LTrim$(RTrim$(frmMDI.ActiveForm.Grid1.Text))
Next

'wczytanie danych
For i = 1 To ArkuszHeight
 frmMDI.ActiveForm.Grid1.Row = i
 For j = 1 To ArkuszWidth
  frmMDI.ActiveForm.Grid1.Col = j + 1
  DaneMaczka(i, j) = Val(LTrim$(RTrim$(frmMDI.ActiveForm.Grid1.Text)))
  If Err Then
   MsgBox "Data Error. Row=" + Str$(i) + ", Col=" + Str$(j), 0 + 16
   Screen.MousePointer = 0
   Exit Sub
  End If
  If LTrim$(RTrim$(frmMDI.ActiveForm.Grid1.Text)) = "" Then
   frmMDI.ActiveForm.Grid1.Text = "0.0"
  End If
 Next
Next

ReDim Suma(1 To ArkuszWidth)
ReDim SumaKwadrat(1 To ArkuszWidth)
ReDim Average(1 To ArkuszWidth)
ReDim Wariancja(1 To ArkuszWidth)
ReDim Standard(1 To ArkuszWidth)

For i = 1 To ArkuszWidth
   For j = 1 To ArkuszHeight
     Suma(i) = Suma(i) + DaneMaczka(j, i)
   Next
   Average(i) = Suma(i) / ArkuszHeight
Next

For i = 1 To ArkuszWidth
  For j = 1 To ArkuszHeight
    SumaKwadrat(i) = SumaKwadrat(i) + (DaneMaczka(j, i) - Average(i)) ^ 2
  Next
 Next
 For i = 1 To ArkuszWidth
  Wariancja(i) = SumaKwadrat(i) / (ArkuszHeight - 1)
  Standard(i) = Sqr(Wariancja(i))
 Next
 
Screen.MousePointer = vbDefault

End Sub

Sub DeleteRecord()
If gAnaliza = 1 Then
   Beep
   Exit Sub
End If

Dim odp, Numer, Info, i

If frmMDI.ActiveForm.Grid1.Row < 1 Then
   Beep
   Exit Sub
End If

If frmMDI.ActiveForm.Grid1.Rows >= 2 And frmMDI.ActiveForm.Grid1.Row > 0 Then
   Info = "Delete record number " + Str$(frmMDI.ActiveForm.Grid1.Row) + "?"
   Numer = frmMDI.ActiveForm.Grid1.Row
   odp = MsgBox(Info, 4, "Delete")

   If odp = 6 Then
      Kasowanie = 1
      If frmMDI.ActiveForm.Grid1.Rows = 2 And frmMDI.ActiveForm.Grid1.Row = 1 Then
         frmMDI.ActiveForm.Grid1.Row = frmMDI.ActiveForm.Grid1.Rows - 1
         For i = 1 To frmMDI.ActiveForm.Grid1.Cols - 1
            frmMDI.ActiveForm.Grid1.Col = i
            frmMDI.ActiveForm.Grid1.Text = ""
         Next
      Else
         frmMDI.ActiveForm.Grid1.RemoveItem Numer 'usuwa wiersz
      End If

      frmMDI.ActiveForm.Grid1.Col = 0
     
      For i = 1 To frmMDI.ActiveForm.Grid1.Rows - 1
         frmMDI.ActiveForm.Grid1.Row = i
         frmMDI.ActiveForm.Grid1.Text = Str$(i) 'numery wierszy z rekordami
      Next i

      frmMDI.ActiveForm.Grid1.Col = 2

      Zmiana = True ' zaznaczenie zmiany
      FState(frmMDI.ActiveForm.Tag).Dirty = True

   ElseIf odp = 7 Then
      frmMDI.ActiveForm.Grid1.Row = Numer
   End If
Else
   MsgBox "Brak wierszy do usunicia"
End If

frmMDI.ActiveForm.Grid1.SetFocus

End Sub

Sub EditCopyProc()
   ' Copy selected text to Clipboard.
   Clipboard.SetText frmMDI.ActiveForm.ActiveControl.SelText
End Sub

Sub EditCutProc()
   ' Copy selected text to Clipboard.
   Clipboard.SetText frmMDI.ActiveForm.ActiveControl.SelText
   ' Delete selected text.
   frmMDI.ActiveForm.ActiveControl.SelText = ""
End Sub

Sub EditPasteProc()
    ' Place text from Clipboard into active control.
    frmMDI.ActiveForm.ActiveControl.SelText = Clipboard.GetText()
End Sub

Sub FileNew()
If gAnaliza = 1 Then
 Beep
 Exit Sub
End If
    
Dim fIndex As Integer
Dim x%
Dim i As Long, j As Long

frmNowy.Show vbModal
If GoNew = -99 Then Exit Sub

fIndex = FindFreeIndex()
document(fIndex).Tag = fIndex
document(fIndex).Caption = "[DATA]: Untitled:" & fIndex
document(fIndex).Grid1.SetFocus

'Just some code to make the grid interesting
document(fIndex).Grid1.Cols = LiczbaZmiennych + 2 'plus dwa poniewa dochodzi kolumna na etykiety
document(fIndex).Grid1.Rows = LiczbaRekordow + 1 'wiersz gwny plus liczba rekordw
 
document(fIndex).Grid1.Row = 0
document(fIndex).Grid1.Col = 0
document(fIndex).Grid1.Text = "Number"

document(fIndex).Grid1.Col = 0
document(fIndex).Grid1.COLWIDTH(0) = 900

For x% = 1 To document(fIndex).Grid1.Rows - 1
   document(fIndex).Grid1.Row = x%
   document(fIndex).Grid1.Text = Str$(x%) 'numery wierszy z rekordami
Next x%
   
document(fIndex).Grid1.Col = 1
For x% = 1 To document(fIndex).Grid1.Rows - 1
   document(fIndex).Grid1.Row = x%
   document(fIndex).Grid1.Text = "Record" + Str$(x%) 'nazwy rekordw
Next x%


document(fIndex).Grid1.FixedAlignment(0) = 2 'wyrodkowanie numerw

document(fIndex).Grid1.Row = 0
For x% = 1 To document(fIndex).Grid1.Cols - 1
   If x% = 1 Then
      document(fIndex).Grid1.COLWIDTH(x%) = 1800
      document(fIndex).Grid1.FixedAlignment(x%) = 0      'Left aligned
      document(fIndex).Grid1.ColAlignment(x%) = 0      'Left aligned
   Else
      document(fIndex).Grid1.COLWIDTH(x%) = 900
      document(fIndex).Grid1.FixedAlignment(x%) = 1      'right aligned
      document(fIndex).Grid1.ColAlignment(x%) = 1      'right aligned
   End If
   document(fIndex).Grid1.Col = x%
   If x% = 1 Then
      document(fIndex).Grid1.Text = "Record Name"
   Else
      document(fIndex).Grid1.Text = "VAR " + Str$(x% - 1)
   End If
Next x%

For i = 1 To document(fIndex).Grid1.Rows - 1
   document(fIndex).Grid1.Row = i
   For j = 2 To document(fIndex).Grid1.Cols - 1
      document(fIndex).Grid1.Col = j
      document(fIndex).Grid1.Text = "0.000"
   Next j
Next i

document(fIndex).WindowState = 0
document(fIndex).Width = 0.95 * Screen.Width
document(fIndex).Height = 0.8 * Screen.Height
document(fIndex).Left = 0
document(fIndex).Top = 0
document(fIndex).Show
    
End Sub

Function FindFreeIndex() As Integer
Dim i As Integer
Dim ArrayCount As Integer

ArrayCount = UBound(document)

' Cycle throught the document array. If one of the
' documents has been deleted, then return that
' index.
For i = 1 To ArrayCount
   If FState(i).Deleted Then
      FindFreeIndex = i
      FState(i).Deleted = False
      Exit Function
   End If
Next

' If none of the elements in the document array have
' been deleted, then increment the document and the
' state arrays by one and return the index to the
' new element.

ReDim Preserve document(ArrayCount + 1)
ReDim Preserve FState(ArrayCount + 1)
FindFreeIndex = UBound(document)
End Function

Sub FindIt()
Dim start, pos, findstring, sourcestring, msg, Response, Offset
    
If (gCurPos = frmMDI.ActiveForm.ActiveControl.SelStart) Then
   Offset = 1
Else
   Offset = 0
End If

    If gFirstTime Then Offset = 0

    start = frmMDI.ActiveForm.ActiveControl.SelStart + Offset
        
    If gFindCase Then
        findstring = gFindString
        sourcestring = frmMDI.ActiveForm.ActiveControl.Text
    Else
        findstring = UCase(gFindString)
        sourcestring = UCase(frmMDI.ActiveForm.ActiveControl.Text)
    End If
            
    If gFindDirection = 1 Then
        pos = InStr(start + 1, sourcestring, findstring)
    Else
        For pos = start - 1 To 0 Step -1
            If pos = 0 Then Exit For
            If Mid(sourcestring, pos, Len(findstring)) = findstring Then Exit For
        Next
    End If

    ' If string is found
    If pos Then
        frmMDI.ActiveForm.ActiveControl.SelStart = pos - 1
        frmMDI.ActiveForm.ActiveControl.SelLength = Len(findstring)
    Else
        msg = "Cannot find " & Chr(34) & gFindString & Chr(34)
        Response = MsgBox(msg, 0, App.Title)
    End If
    
    gCurPos = frmMDI.ActiveForm.ActiveControl.SelStart
    gFirstTime = False

End Sub

Sub GetRecentFiles()
 ' This procedure demonstrates the use of the GetAllSettings function,
 ' which returns an array of values from the Windows registry. In this
 ' case, the registry contains the files most recently opened.  Use the
 ' SaveSetting statement to write the names of the most recent files.
 ' That statement is used in the WriteRecentFiles procedure.
 Dim i, j As Integer
 Dim varFiles As Variant ' Varible to store the returned array.
    
 ' Get recent files from the registry using the GetAllSettings statement.
 ' ThisApp and ThisKey are constants defined in this module.
 If GetSetting(ThisApp, ThisKey, "RecentFile1") = Empty Then Exit Sub
    
 varFiles = GetAllSettings(ThisApp, ThisKey)
    
   For i = 0 To UBound(varFiles, 1)
        
      frmMDI.mnuRecentFile(0).Visible = True
      frmMDI.mnuRecentFile(i).Caption = varFiles(i, 1)
      frmMDI.mnuRecentFile(i).Visible = True
         ' Iterate through all the documents and update each menu.
         'For j = 1 To UBound(document)
         '    If Not FState(j).Deleted Then
         '        document(j).mnuRecentFile(0).Visible = True
         '        document(j).mnuRecentFile(i + 1).Caption = varFiles(i, 1)
         '        document(j).mnuRecentFile(i + 1).Visible = True
         '    End If
         'Next j
   Next i
 
End Sub

Sub ImportDBase()
If gAnaliza = 1 Then
   Exit Sub
End If

frmImpDBF.Show vbModal
If Dalej = -99 Then Exit Sub

' reset mouse pointer
Screen.MousePointer = vbHourglass

Dim fIndex As Integer

' change form's caption and display new data
fIndex = FindFreeIndex()
document(fIndex).Tag = fIndex
document(fIndex).Caption = "[DATA]: Untitled:" & fIndex
document(fIndex).OpisText = "Data from " & xtrim(Baza.File)

document(fIndex).Grid1.Cols = Przekaznik2 + 2 'plus dwa poniewa dochodzi kolumna na etykiety
document(fIndex).Grid1.Rows = Przekaznik + 1 'plus dwa poniewa dochodzi wiersz gowny z nazwami cech

document(fIndex).Grid1.Row = 0
document(fIndex).Grid1.Col = 0
document(fIndex).Grid1.Text = "Number"

document(fIndex).Grid1.Col = 0
document(fIndex).Grid1.COLWIDTH(0) = 900
Dim JakaSzer, x%, y%, i
JakaSzer = 900

For x% = 1 To document(fIndex).Grid1.Rows - 1
   document(fIndex).Grid1.Row = x%
   document(fIndex).Grid1.Text = Str$(x%) 'numery wierszy z rekordami
Next x%

document(fIndex).Grid1.FixedAlignment(0) = 2 'wyrodkowanie numerw

document(fIndex).Grid1.Row = 0
For x% = 1 To document(fIndex).Grid1.Cols - 1
   If x% = 1 Then
      document(fIndex).Grid1.COLWIDTH(x%) = 1800
      JakaSzer = JakaSzer + 1800
      document(fIndex).Grid1.FixedAlignment(x%) = 0      'left aligned
      document(fIndex).Grid1.ColAlignment(x%) = 0      'left aligned
   Else
      document(fIndex).Grid1.COLWIDTH(x%) = 900
      JakaSzer = JakaSzer + 900
      document(fIndex).Grid1.FixedAlignment(x%) = 1      'right aligned
      document(fIndex).Grid1.ColAlignment(x%) = 1      'right aligned
   End If
   document(fIndex).Grid1.Col = x%
   If x% = 1 Then
      document(fIndex).Grid1.Text = "Record Name"
   Else
      document(fIndex).Grid1.Text = Etykiety(x% - 1)
   End If
Next x%

document(fIndex).Grid1.Col = 0
For i = 1 To document(fIndex).Grid1.Cols - 1
   document(fIndex).Grid1.FixedAlignment(i) = 2
Next

document(fIndex).Grid1.Row = 1
document(fIndex).Grid1.Col = 1
For x% = 1 To document(fIndex).Grid1.Rows - 1
   document(fIndex).Grid1.Row = x%
   document(fIndex).Grid1.Text = RecInfo(x%)
Next x%

'deklaracja formatu wprowadzanych danych
Dim strFmt As String
strFmt = "###0.000"

For x% = 1 To document(fIndex).Grid1.Rows - 1
   For y% = 2 To document(fIndex).Grid1.Cols - 1
      document(fIndex).Grid1.Row = x%
      document(fIndex).Grid1.Col = y%
      document(fIndex).Grid1.Text = Format$(DaneMaczka(x%, y% - 1), strFmt)
   Next
Next

document(fIndex).Grid1.Visible = True
document(fIndex).TopPanel.Visible = True
document(fIndex).Grid1.Row = 1
document(fIndex).Grid1.Col = 1
document(fIndex).Grid1.SetFocus
document(fIndex).SzerOkno = JakaSzer
document(fIndex).Grid1.SetFocus
FState(fIndex).Dirty = True
document(fIndex).WindowState = 0
document(fIndex).Width = 0.95 * Screen.Width
document(fIndex).Height = 0.8 * Screen.Height
document(fIndex).Left = 0
document(fIndex).Top = 0
document(fIndex).Show
    
' reset mouse pointer
Screen.MousePointer = vbDefault
End Sub

Function GetWidth(sMaks As Single) As Single
If Len(CStr(sMaks)) < 6 Then
   GetWidth = 1
ElseIf Len(CStr(sMaks)) = 6 Then
   GetWidth = 1.3
ElseIf Len(CStr(sMaks)) = 7 Then
   GetWidth = 1.5
ElseIf Len(CStr(sMaks)) = 8 Then
   GetWidth = 1.75
ElseIf Len(CStr(sMaks)) = 9 Then
   GetWidth = 2
ElseIf Len(CStr(sMaks)) = 10 Then
   GetWidth = 2.3
ElseIf Len(CStr(sMaks)) = 11 Then
   GetWidth = 2.5
ElseIf Len(CStr(sMaks)) >= 12 Then
   GetWidth = 2.75
End If
End Function

Sub ImportMatrix()
'********************************************************
'Procedura ImportMatrix
'importuje macierz odlegoci z pliku tekstowego
'********************************************************
If gAnaliza = 1 Then
   Beep
   Exit Sub
End If

frmImpMatrix.Show vbModal
If Dalej = -99 Then Exit Sub

'tu wlasciwy import danych
'ImpMatrix.

Dim F1 As Integer
Dim strWiersz As String
Dim strTab() As String
Dim strTemp(1 To 150, 1 To 150) As String
Dim strComma As String
Dim i As Integer, j As Integer
Dim ArkuszHeight As Long

Select Case ImpMatrix.Comma
   Case 1
      strComma = ";"
   Case 2
      strComma = ","
   Case 3
      strComma = Chr$(9)
End Select

F1 = FreeFile

'On Error GoTo ImpMatrixError

'sprawdzenie liczby obiektow...
Open ImpMatrix.FileName For Input As #F1
   Line Input #F1, strWiersz
   strTab = Split(strWiersz, strComma)
Close #F1

'...zaleznie od tego czy pierwsza kolumna zawiera nazwy obiektow
If ImpMatrix.FirstCol Then
   ArkuszHeight = UBound(strTab)
Else
   ArkuszHeight = UBound(strTab) + 1
End If

'sprawdzenie czy macierz nie jest zbyt duza
If ArkuszHeight > gMaxObject Then
   MsgBox "Matrix > " & CStr(gMaxObject), vbExclamation
   Exit Sub
End If

'Zmiana rozmiaru tablic na wsp. odl/podob. i inf. o rekordach
ReDim Dystans(1 To ArkuszHeight, 1 To ArkuszHeight)
ReDim RecInfo(1 To ArkuszHeight)

F1 = FreeFile

i = 0

Dim sLiczba As Single
Dim strFormat As String

'tu definicja formatu
If ImpMatrix.Precision > 0 Then
   strFormat = "#0." & String(CLng(ImpMatrix.Precision), "0")
Else
   strFormat = "#####0"
End If

Open ImpMatrix.FileName For Input As #F1
Do Until EOF(F1)
   Line Input #F1, strWiersz
   strTab = Split(strWiersz, strComma)
   i = i + 1
   If i > ArkuszHeight Then
      MsgBox "Invalid matrix: height <> width, or option: Record names in first column is invalid.", vbExclamation + vbOKOnly, "Import matrix"
      Exit Do
   End If
   If ImpMatrix.FirstCol Then
      RecInfo(i) = strTab(0)
      For j = 1 To ArkuszHeight
         sLiczba = Abs(CSng(strTab(j))) 'wartosc bezwzgledna
         Dystans(i, j) = CSng(Format$(sLiczba, strFormat))
      Next
   Else
      RecInfo(i) = "Record " & CStr(i)
      For j = 1 To ArkuszHeight
         sLiczba = Abs(CSng(strTab(j - 1))) 'wartosc bezwzgledna
         Dystans(i, j) = CSng(Format$(sLiczba, strFormat))
      Next
   End If
Loop
Close #F1

'tu utworzenie nowego okna z macierza

Dim Maksymalny As Single
Maksymalny = 0
For i = 1 To ArkuszHeight
   For j = 1 To ArkuszHeight
      If Len(CStr(Dystans(i, j))) >= Len(CStr(Maksymalny)) Then
         Maksymalny = Dystans(i, j)
      End If
   Next
Next

' change form's caption and display new text
Dim fIndex As Integer
fIndex = 0
fIndex = MFindFreeIndex()
gIndex = fIndex 'zapis do zmiennej globalnej indeksu tablicy MatPar
MatPar(fIndex).Height = ArkuszHeight
Macierz(fIndex).Tag = fIndex
ReDim MatPar(fIndex).Distance(1 To ArkuszHeight, 1 To ArkuszHeight)
ReDim MatPar(fIndex).RecInfo(1 To ArkuszHeight)
MatPar(fIndex).FileName = ImpMatrix.FileName
Macierz(fIndex).Caption = "[MATRIX]: Imported matrix"
Macierz(fIndex).BottomText = LTrim$(RTrim$("Matrix from: " & ImpMatrix.FileName))

'zapis macierzy odleglosci i tablicy nazw rekordw do wewnetrznej tablicy macierzy
For i = 1 To ArkuszHeight
   MatPar(fIndex).RecInfo(i) = RecInfo(i)
   For j = 1 To ArkuszHeight
      MatPar(fIndex).Distance(i, j) = Dystans(i, j)
   Next
Next

'zapis macierzy do okna
Macierz(fIndex).Siatka.Rows = ArkuszHeight + 1
Macierz(fIndex).Siatka.Cols = ArkuszHeight + 2

For i = 0 To ArkuszHeight + 1
   Macierz(fIndex).Siatka.FixedAlignment(i) = 2
Next

Macierz(fIndex).Siatka.Col = 0
For i = 1 To ArkuszHeight
   Macierz(fIndex).Siatka.Row = i
   Macierz(fIndex).Siatka.Text = i
Next

Macierz(fIndex).Siatka.Col = 1
Macierz(fIndex).Siatka.COLWIDTH(1) = Macierz(fIndex).Siatka.COLWIDTH(1) * 3
For i = 1 To ArkuszHeight
   Macierz(fIndex).Siatka.Row = i
   Macierz(fIndex).Siatka.Text = RecInfo(i)
Next

Macierz(fIndex).Siatka.Row = 0
For i = 2 To ArkuszHeight + 1
   Macierz(fIndex).Siatka.Col = i
   Macierz(fIndex).Siatka.ColAlignment(i) = 1
   Macierz(fIndex).Siatka.COLWIDTH(i) = Macierz(fIndex).Siatka.COLWIDTH(i) * GetWidth(Maksymalny)
   Macierz(fIndex).Siatka.Text = i - 1
Next

For i = 1 To ArkuszHeight
   For j = 2 To ArkuszHeight + 1
      Macierz(fIndex).Siatka.Row = i
      Macierz(fIndex).Siatka.Col = j
      Macierz(fIndex).Siatka.Text = Format$(Dystans(i, j - 1), strFormat)
   Next
Next

MState(fIndex).Dirty = True
Macierz(fIndex).WindowState = 0
If Macierz(fIndex).WindowState = 0 Then
   Macierz(fIndex).Width = 0.95 * Screen.Width
   Macierz(fIndex).Height = 0.8 * Screen.Height
End If
Macierz(fIndex).Left = 0
Macierz(fIndex).Top = 0
Macierz(fIndex).Show

' reset mouse pointer
Screen.MousePointer = vbDefault

Exit Sub

ImpMatrixError:
   MsgBox "Error :" & Err.Description & vbCrLf & "File: " & ImpMatrix.FileName, vbCritical
   Err = 0
End Sub

Sub ImportText()
If gAnaliza = 1 Then
   Beep
   Exit Sub
End If
    
frmImportText.Show 1
If Dalej = -99 Then Exit Sub

Dim p As Integer
Dim LiczbaRekord As Integer, i As Integer, j As Integer
Dim k As Integer
Dim Tekst As String, Wiersz As String
Dim Separator As String * 1
ReDim Etykiety3(1 To 100) As String
ReDim Rec3Info(1 To 2000)
ReDim DaneImport(1 To 2000, 1 To 100)
Dim dlFile
p = FreeFile

If FileLen(ImportFile) <= 65500 Then
   Open ImportFile For Input As #p
   Tekst = Input$(LOF(p), p)
   dlFile = FileLen(ImportFile)
Else
   Open ImportFile For Input As #p
   Tekst = Input$(65500, #p)
   dlFile = 65500
End If

If CommaType = 1 Then
   Separator = ";"
ElseIf CommaType = 3 Then
   Separator = Chr$(9)
End If

If VarName = 1 Then
   i = 0: j = 0: Wiersz = ""
   Do Until i = dlFile
      i = i + 1
      If Mid$(Tekst, i, 1) = Chr$(10) Then
         j = j + 1   'zwikszenie liczby zmiennych o 1
         If j > 100 Then 'za duo zmiennych!
            MsgBox "Over 100 variables!", 0 + 16
            Exit Sub
         End If
         Etykiety3(j) = Wiersz
         Wiersz = ""
         Exit Do
      ElseIf Mid$(Tekst, i, 1) = Chr$(13) Then
         j = j + 1   'zwikszenie liczby zmiennych o 1
         If j > 100 Then 'za duo zmiennych!
            MsgBox "Over 100 variables!", 0 + 16
            Exit Sub
         End If
         Etykiety3(j) = Wiersz
         Wiersz = ""
         Exit Do
      ElseIf Mid$(Tekst, i, 1) = Separator Then
         j = j + 1   'zwikszenie liczby zmiennych o 1
         If j > 100 Then    'za duo zmiennych!
            MsgBox "Over 100 variables!", 0 + 16
            Exit Sub
         End If
         Etykiety3(j) = Wiersz
         Wiersz = ""
      Else
         Wiersz = Wiersz + Mid$(Tekst, i, 1)
      End If
   Loop
   LiczbaZmiennych = j
Else
   i = 0: j = 0: Wiersz = ""
   Do Until i = dlFile
      i = i + 1
      If Mid$(Tekst, i, 1) = Chr$(10) Then
         j = j + 1   'zwikszenie liczby zmiennych o 1
         If j > 100 Then 'za duo zmiennych!
            MsgBox "Over 100 variables!", 0 + 16
            Exit Sub
         End If
         Exit Do
      ElseIf Mid$(Tekst, i, 1) = Chr$(13) Then
         j = j + 1   'zwikszenie liczby zmiennych o 1
         If j > 100 Then 'za duo zmiennych!
            MsgBox "Over 100 variables!", 0 + 16
            Exit Sub
         End If
         Exit Do
      ElseIf Mid$(Tekst, i, 1) = Separator Then
         j = j + 1   'zwikszenie liczby zmiennych o 1
         If j > 100 Then 'za duo zmiennych!
            MsgBox "Over 100 variables!", 0 + 16
            Exit Sub
         End If
      Else
      End If
   Loop
      
   If RecName = 1 Then
      LiczbaZmiennych = j - 1
   Else
      LiczbaZmiennych = j
   End If
End If

i = 0: j = 0: Wiersz = ""

If VarName = 1 Then
   k = 0
Else
   k = 1
End If

Do Until i = dlFile
   i = i + 1
   If Mid$(Tekst, i, 1) = Chr$(13) And Mid$(Tekst, i + 1, 1) = Chr$(10) Then
      j = j + 1   'zwikszenie numeru zmiennych o 1
      If j > 100 Then 'za duo zmiennych!
         MsgBox "Over 100 variables!", 0 + 16
         Exit Sub
      End If
      If RecName = 1 Then
         If j = 1 Then
            If k > 0 Then Rec3Info(k) = Wiersz
         Else
            If k > 0 Then DaneImport(k, j - 1) = Val(Wiersz)
            If Err Then
               MsgBox "Data error. Row " + Str$(k) + "Col " + Str$(j)
               Err = 0
               Exit Sub
            End If
         End If
      Else
         If k > 0 Then DaneImport(k, j) = Val(Wiersz)
         If Err Then
            MsgBox "Data error. Row " + Str$(k) + "Col " + Str$(j)
            Err = 0
            Exit Sub
         End If
      End If

      k = k + 1
      i = i + 1
      j = 0
      Wiersz = ""
ElseIf Mid$(Tekst, i, 1) = Separator Then
   j = j + 1   'zwikszenie numeru zmiennych o 1
   If j > 100 Then 'za duo zmiennych!
      MsgBox "Over 100 variables!", 0 + 16
      Exit Sub
   End If

   If RecName = 1 Then
      If j = 1 Then
         If k > 0 Then Rec3Info(k) = Wiersz
      Else
         If k > 0 Then DaneImport(k, j - 1) = Val(Wiersz)
         If Err Then
            MsgBox "Data error. Row " + Str$(k) + "Col " + Str$(j)
            Err = 0
            Exit Sub
         End If
      End If
   Else
      If k > 0 Then DaneImport(k, j) = Val(Wiersz)
      If Err Then
         MsgBox "Data error. Row " + Str$(k) + "Col " + Str$(j)
         Err = 0
         Exit Sub
      End If
   End If
   Wiersz = ""
Else
   Wiersz = Wiersz + Mid$(Tekst, i, 1)
End If
Loop
LiczbaRekord = k - 1

Close #p

ReDim RecInfo(1 To LiczbaRekord)
ReDim Etykiety(1 To LiczbaZmiennych)
ReDim DaneMaczka(1 To LiczbaRekord, 1 To LiczbaZmiennych)

If VarName = 1 Then
   For i = 1 To LiczbaZmiennych
      Etykiety(i) = Etykiety3(i)
   Next
Else
   For i = 1 To LiczbaZmiennych
      Etykiety(i) = ""
   Next
End If

If RecName = 1 Then
   For i = 1 To LiczbaRekord
      RecInfo(i) = Rec3Info(i)
   Next
Else
   For i = 1 To LiczbaRekord
      RecInfo(i) = ""
   Next
End If

For i = 1 To LiczbaRekord
   For j = 1 To LiczbaZmiennych
      DaneMaczka(i, j) = DaneImport(i, j)
   Next
Next

Dim fIndex

Screen.MousePointer = vbHourglass

' change form's caption and display new data
fIndex = FindFreeIndex()
document(fIndex).Tag = fIndex
document(fIndex).Caption = "[DATA]: Untitled" & fIndex
document(fIndex).OpisText = ""

'Just some code to make the grid interesting
document(fIndex).Grid1.Cols = LiczbaZmiennych + 2 'plus dwa poniewa dochodzi kolumna na etykiety
document(fIndex).Grid1.Rows = LiczbaRekord + 1 'plus dwa poniewa dochodzi wiersz gowny z nazwami cech

document(fIndex).Grid1.Row = 0
document(fIndex).Grid1.Col = 0
document(fIndex).Grid1.Text = "Number"

document(fIndex).Grid1.Col = 0
document(fIndex).Grid1.COLWIDTH(0) = 900
Dim JakaSzer, x%, y%
JakaSzer = 900

For x% = 1 To document(fIndex).Grid1.Rows - 1
   document(fIndex).Grid1.Row = x%
   document(fIndex).Grid1.Text = Str$(x%) 'numery wierszy z rekordami
Next x%

document(fIndex).Grid1.FixedAlignment(0) = 2 'wyrodkowanie numerw

document(fIndex).Grid1.Row = 0
For x% = 1 To document(fIndex).Grid1.Cols - 1
   If x% = 1 Then
      document(fIndex).Grid1.COLWIDTH(x%) = 1800
      JakaSzer = JakaSzer + 1800
      document(fIndex).Grid1.FixedAlignment(x%) = 0      'left aligned
      document(fIndex).Grid1.ColAlignment(x%) = 0      'left aligned
   Else
      document(fIndex).Grid1.COLWIDTH(x%) = 900
      JakaSzer = JakaSzer + 900
      document(fIndex).Grid1.FixedAlignment(x%) = 1      'right aligned
      document(fIndex).Grid1.ColAlignment(x%) = 1      'right aligned
   End If
   document(fIndex).Grid1.Col = x%
   If x% = 1 Then
      document(fIndex).Grid1.Text = "Record Name"
   Else
      If Etykiety(x% - 1) = "" Then
         document(fIndex).Grid1.Text = "VAR " + Str$((x% - 1))
      Else
         document(fIndex).Grid1.Text = Etykiety(x% - 1)
      End If
   End If
Next x%

document(fIndex).Grid1.Col = 0
For i = 1 To document(fIndex).Grid1.Cols - 1
   document(fIndex).Grid1.FixedAlignment(i) = 2
Next

document(fIndex).Grid1.Row = 1
document(fIndex).Grid1.Col = 1
For x% = 1 To document(fIndex).Grid1.Rows - 1
   document(fIndex).Grid1.Row = x%
   document(fIndex).Grid1.Text = RecInfo(x%)
Next x%

'deklaracja formatu wprowadzanych danych
Dim strFmt As String
strFmt = "###0.000"

For x% = 1 To document(fIndex).Grid1.Rows - 1
   For y% = 2 To document(fIndex).Grid1.Cols - 1
      document(fIndex).Grid1.Row = x%
      document(fIndex).Grid1.Col = y%
      document(fIndex).Grid1.Text = Format$(DaneMaczka(x%, y% - 1), strFmt)
   Next
Next

document(fIndex).Grid1.Visible = True
document(fIndex).TopPanel.Visible = True
document(fIndex).Grid1.Row = 1
document(fIndex).Grid1.Col = 1
document(fIndex).Grid1.SetFocus
document(fIndex).SzerOkno = JakaSzer
document(fIndex).Grid1.SetFocus
FState(fIndex).Dirty = True
document(fIndex).WindowState = 0
document(fIndex).Width = 0.95 * Screen.Width
document(fIndex).Height = 0.8 * Screen.Height
document(fIndex).Left = 0
document(fIndex).Top = 0
document(fIndex).Show
    
' reset mouse pointer
Screen.MousePointer = vbDefault

End Sub

Function Losuj(Min As Long, Max As Long)
'Randomize Timer
Losuj = Int((Max - Min + 1) * Rnd + Min)
End Function

Sub MaczekHelp()
If gAnaliza = 1 Then
   Beep
   Exit Sub
End If

Dim nRet As Integer

'if there is no helpfile for this project display a message to the user
'you can set the HelpFile for your application in the
'Project Properties dialog
If Len(App.HelpFile) = 0 Then
   MsgBox "Nie mona wywietli pliku pomocy. Brak pliku pomocy skojarzonego z tym programem.", vbInformation, App.Title
Else
   On Error Resume Next
   nRet = OSWinHelp(frmMDI.hwnd, App.HelpFile, 3, 0)
   If Err Then
      MsgBox Err.Description
   End If
End If

End Sub

'---------------------------------------------------------------------------------------
' Procedure : MakeCzekanowski
' DateTime  : 23-03-2003
' Author    : piotr
' Purpose   : tworzy diagram z danych lub gotowej macierzy
'---------------------------------------------------------------------------------------
'
Sub MakeCzekanowski()
If gAnaliza = 1 Then
   Beep
   Exit Sub
End If

Dim ArkuszWidth As Long, ArkuszHeight As Long
Dim i As Long, j As Long, k As Long
Dim boOblicz As Boolean

Dim Minimalny As Single, Bliski As Integer

Err = 0 ' zerowanie bdw

If gFromMatrix = False Then 'false = from data, true = from matrix
   frmMDI.ActiveForm.Grid1.SetFocus
   ArkuszWidth = frmMDI.ActiveForm.Grid1.Cols - 2
   ArkuszHeight = frmMDI.ActiveForm.Grid1.Rows - 1
Else
   Dim intActive As Integer
   intActive = frmMDI.ActiveForm.Index
   ArkuszHeight = MatPar(intActive).Height
End If

If ArkuszHeight < 2 Then
   MsgBox "The number of records is less than 2. How make diagram?", 0 + 16
   Exit Sub
End If

If ArkuszHeight > gMaxObject Then
   MsgBox "The number of records is more than " & CStr(gMaxObject) & "!", 0 + 16
   Exit Sub
End If

gArkuszHeight = ArkuszHeight

frmPrzedzal.Show vbModal
If Dalej = -99 Then Exit Sub
DoEvents

'wczytanie danych z arkusza
If Not gFromMatrix Then
   If Not GetDataFromGrid Then
      Exit Sub
   End If
End If

If gDataNA = True And DystansType > 2 Then
   MsgBox "Nieprawidowa funkcja odlegoci dla danych niepenych!", vbExclamation, "MaCzek"
   Exit Sub
End If

gAnaliza = 1 'flaga do analizy

ReDim Grupa(1 To ArkuszHeight, 1 To ArkuszHeight)
ReDim Dys_S(1 To ArkuszHeight)
ReDim Dys_P(1 To ArkuszHeight)

'obliczenie macierzy odlegoci
If Not gFromMatrix Then
   boOblicz = ComputeMatrix(ArkuszHeight, ArkuszWidth)
   If Not boOblicz Then
      Exit Sub
   End If
Else
   ReDim Dystans(1 To ArkuszHeight, 1 To ArkuszHeight)
   For i = 1 To ArkuszHeight
      For j = 1 To ArkuszHeight
         Dystans(i, j) = MatPar(intActive).Distance(i, j)
      Next
   Next
End If

ReDim Dystans2(1 To ArkuszHeight, 1 To ArkuszHeight) As Byte
ReDim Wy(1 To ArkuszHeight)
ReDim Kolejka(1 To ArkuszHeight)
If Not gFromMatrix Then
   ReDim Dane2(1 To ArkuszHeight, 1 To ArkuszWidth)
End If
ReDim Rec3Info(1 To ArkuszHeight)

If Not gFromMatrix Then
   For i = 1 To ArkuszHeight
      For j = 1 To ArkuszWidth
         Dane2(i, j) = DaneMaczka(i, j)
      Next
   Next
End If

If Not gFromMatrix Then
   For i = 1 To ArkuszHeight
      Rec3Info(i) = RecInfo(i)
   Next
Else
   For i = 1 To ArkuszHeight
      Rec3Info(i) = MatPar(intActive).RecInfo(i)
   Next
End If

Dim Calcul() As Single
ReDim Calcul(1 To ArkuszHeight * (ArkuszHeight - 1) / 2)
Dim Maksymalny As Single
Dim iTmp As Long
Maksymalny = 0
For i = 1 To ArkuszHeight
   For j = 1 To ArkuszHeight
      If i > j Then
         iTmp = (i - 1) * (i - 2) / 2 + j
         Calcul((i - 1) * (i - 2) / 2 + j) = Dystans(i, j)
      End If
      If Dystans(i, j) >= Maksymalny Then
         Maksymalny = Dystans(i, j)
      End If
   Next
Next

SortSngAsc Calcul()
Przedzial(1) = Calcul(CInt(0.2 * UBound(Calcul)))
Przedzial(2) = Calcul(CInt(0.4 * UBound(Calcul)))
Przedzial(3) = Calcul(CInt(0.6 * UBound(Calcul)))
Przedzial(4) = Calcul(CInt(0.8 * UBound(Calcul)))

Dim x As Integer, y As Integer, Zamienna As Integer, UmGen As Single
Dim m As Integer, LiczbaZmian As Integer
Dim sngProcent As Single, sngMinF As Single
Dim Winner As Integer
Dim Min As Variant
Dim sngCzas1 As Single, sngCzas2 As Single, strCzas3 As String
Dim l, n, TypZmiany As Integer, BrakZmian

If OrderType = 3 Then
   ReDim Chromosom(1 To NumberChromo, 1 To ArkuszHeight) As Integer
   ReDim Pierwotny(1 To ArkuszHeight) As Integer
   ReDim Funkcja(1 To NumberChromo) As Single
End If

If OrderType = 4 Then
   ReDim Chromosom(1 To 2, 1 To ArkuszHeight) As Integer
   ReDim Pierwotny(1 To ArkuszHeight) As Integer
   ReDim BestPierwotny(1 To ArkuszHeight) As Integer
   ReDim Funkcja(1 To 2)
End If

'porzdkowanie automatyczne jeli OrderType>1
If OrderType = 2 Then
   Wy(1) = 1: Kolejka(1) = 1
   k = 1: i = 1

   Do
      Minimalny = Maksymalny
      For j = 1 To ArkuszHeight
         If Dystans(i, j) <= Minimalny And Wy(j) <> 1 Then
            Minimalny = Dystans(i, j)
            Bliski = j
         End If
      Next
      k = k + 1
      Kolejka(k) = Bliski
      i = Bliski
      Wy(Bliski) = 1
      If k = ArkuszHeight Then Exit Do
   Loop

   If Not gFromMatrix Then
      For i = 1 To ArkuszHeight
         For j = 1 To ArkuszWidth
            DaneMaczka(i, j) = Dane2(Kolejka(i), j)
         Next
         RecInfo(i) = Rec3Info(Kolejka(i))
      Next
   Else
      ReDim RecInfo(1 To ArkuszHeight)
      For i = 1 To ArkuszHeight
         RecInfo(i) = MatPar(intActive).RecInfo(Kolejka(i))
      Next
   End If
    
   If Not gFromMatrix Then
      boOblicz = ComputeMatrix(ArkuszHeight, ArkuszWidth)
      If Not boOblicz Then
         Exit Sub
      End If
   Else
      For i = 1 To ArkuszHeight
         For j = 1 To ArkuszHeight
            Dystans(i, j) = MatPar(intActive).Distance(Kolejka(i), Kolejka(j))
         Next
      Next
   End If
    
ElseIf OrderType = 3 Then 'porzdkowanie genetyczne
   frmWork.Show
   SetWindowPos frmWork.hwnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE
   
   fStop = False
   k = 1: i = 1: m = 0
   LiczbaZmian = Int(ArkuszHeight / 10)
   If LiczbaZmian < 1 Then LiczbaZmian = 1
   For i = 1 To ArkuszHeight
      Pierwotny(i) = i
   Next
   sngCzas1 = Timer

   Do While DoEvents()
      If fStop = True Then
         fStop = False
         Exit Do
      End If

      m = m + 1
      sngCzas2 = Timer
      strCzas3 = Format$(sngCzas2 - sngCzas1, "###0.0") & " second"
      sngProcent = ((m / MaxMutacja) * 100)
      frmWork.InfoTime = strCzas3
      frmWork.InfoString = Format$(sngProcent, "#0.0") & " %" 'info string
      frmWork.lblFunkcja = Format$(sngMinF, "###0.000") 'tu poprawi
      frmWork.Procent1.Width = (sngProcent / 100) * frmWork.Procent.Width

      For i = 1 To NumberChromo
         For j = 1 To ArkuszHeight
            If m = 1 And i = 1 Then
               Chromosom(i, j) = Pierwotny(j)
            Else
               For k = 1 To ArkuszHeight
                  Chromosom(i, k) = Pierwotny(k)
               Next
               If i > 1 Then 'pierwszy chromosom bez zmian
                  For k = 1 To LiczbaZmian
                     TypZmiany = Losuj(1, 2) '1 zmiana dowolna , 2 zmiana bliska
                     If TypZmiany = 1 Then
                        x = Losuj(1, ArkuszHeight)
                        y = Losuj(1, ArkuszHeight)
                     ElseIf TypZmiany = 2 Then
                        x = Losuj(2, ArkuszHeight - 1)
                        y = Losuj(x - 1, x + 1)
                     End If
                     Zamienna = Chromosom(i, x)
                     Chromosom(i, x) = Chromosom(i, y)
                     Chromosom(i, y) = Zamienna
                  Next
               End If
            End If
         Next
      Next

      'tu sprawdzenie wartoci funkcji F0
      For k = 1 To NumberChromo
         Funkcja(k) = 0
      Next
    
      For k = 1 To NumberChromo
         For l = 1 To ArkuszHeight - 1
            For n = l + 1 To ArkuszHeight
               Funkcja(k) = Funkcja(k) + ((n - l) ^ 2) / ((Dystans(Chromosom(k, l), Chromosom(k, n)) + 1))
            Next
         Next
         Funkcja(k) = Funkcja(k) / ((ArkuszHeight ^ 2) / 2)
      Next

      Min = Funkcja(1): Winner = 1

      For k = 1 To NumberChromo
         If Funkcja(k) < Min Then
            Min = Funkcja(k)
            Winner = k
         End If
      Next

      sngMinF = Funkcja(Winner)

      For k = 1 To ArkuszHeight
         Pierwotny(k) = Chromosom(Winner, k)
      Next
 
      If m = MaxMutacja Then Exit Do
   Loop

   frmWork.InfoString = LTrim$(Str$(100)) + " %" 'info string
   Unload frmWork

   For i = 1 To ArkuszHeight
      If Not gFromMatrix Then
         For j = 1 To ArkuszWidth
            DaneMaczka(i, j) = Dane2(Pierwotny(i), j)
         Next
         RecInfo(i) = Rec3Info(Pierwotny(i))
      Else
         RecInfo(i) = MatPar(intActive).RecInfo(Pierwotny(i))
      End If
   Next
   
   If Not gFromMatrix Then
      boOblicz = ComputeMatrix(ArkuszHeight, ArkuszWidth)
      If Not boOblicz Then
         Exit Sub
      End If
   Else
      For i = 1 To ArkuszHeight
         For j = 1 To ArkuszHeight
            Dystans(i, j) = MatPar(intActive).Distance(Pierwotny(i), Pierwotny(j))
         Next
      Next
   End If
   
'-------------------------------------'''''----------------------
ElseIf OrderType = 4 Then 'porzdkowanie genetyczne UMCzek
   frmWorkUM.Show
   SetWindowPos frmWorkUM.hwnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOACTIVATE Or SWP_SHOWWINDOW Or SWP_NOMOVE Or SWP_NOSIZE
 
   fStop = False

   'konwersja macierzy
   Dim Btemp
   If MatrixCC <> 0 Then
      For i = 1 To ArkuszHeight
         For j = 1 To ArkuszHeight
            If Dystans(i, j) > 255 Then Btemp = 255 Else Btemp = Dystans(i, j)
            Dystans2(i, j) = CByte(Btemp * MatrixCC)
         Next
      Next
   End If

   k = 1: i = 1
 
   For i = 1 To ArkuszHeight
      Pierwotny(i) = i
      BestPierwotny(i) = i
   Next
 
   Dim X1, LFrag, BrakZmian2, Pokolenie, Mutacja
   Dim PMut(1 To 8) As Integer
   Dim Counter1 As Integer, Counter2 As Integer, Counter3 As Integer
    
   PMut(1) = SequenceChange
   PMut(2) = FragmentTransfer
   PMut(3) = SomeSingleTransfers
   PMut(4) = SingleTransfers
   PMut(5) = SomeRemoteConversions
   PMut(6) = RemoteConversion
   PMut(7) = SomeNeighbourConversion
   PMut(8) = NeighbourConversion
    
   For i = 1 To 8
      Probablity = Probablity + PMut(i)
   Next
  
   Pokolenie = 0: Mutacja = 0: UmGen = 0
   sngCzas1 = Timer
    
   For j = 1 To ArkuszHeight
      Chromosom(1, j) = j
      Chromosom(2, j) = j
   Next

   Do While DoEvents() 'gwna ptla
      Pokolenie = Pokolenie + 1
      If fStop = True Then
        'fStop = False
        Exit Do
      End If

      frmWorkUM.Generacje = Str$(Pokolenie)
      frmWorkUM.lblFunkcja.Caption = ""
  
      For j = 1 To ArkuszHeight
        Chromosom(1, j) = BestPierwotny(j)
        Chromosom(2, j) = BestPierwotny(j)
      Next
    
      'losowy porzadek jesli kolejne pokolenie
      Dim Stemp As Integer
    
      If Pokolenie > 1 Then
        For Stemp = 1 To 500
          X1 = Losuj(1, 20)
          For i = 1 To X1 'kilka pojedynczych przesuni
            x = Losuj(1, ArkuszHeight)
            y = Losuj(1, ArkuszHeight)
            Do
              y = Losuj(1, ArkuszHeight)
              If y <> x Then Exit Do
            Loop
            Zamienna = Chromosom(2, x)
            If x > y Then
              For j = x To y + 1 Step -1
                Chromosom(2, j) = Chromosom(2, j - 1)
              Next
              Chromosom(2, y) = Zamienna
            End If
            If x < y Then
              For j = x To y - 1
                Chromosom(2, j) = Chromosom(2, j + 1)
              Next
              Chromosom(2, y) = Zamienna
            End If
          Next 'do i
        Next 'do j
      End If
    
      Dim TempM
      Min = 0
      For l = 1 To ArkuszHeight - 1
        For n = l + 1 To ArkuszHeight
          'tu zmienilem tablice Dystans na Dystans2
          Min = Min + ((Chromosom(1, n) - Chromosom(1, l)) ^ 2) / (Dystans2(Chromosom(1, l), Chromosom(1, n)) + 1)
        Next
      Next
      TempM = 0
      TempM = ((ArkuszHeight ^ 2) / 2)
      Min = Min / TempM
      frmWorkUM.lblFunkcja.Caption = Format$(Min, "###0.00000") 'tu poprawi

 Do While DoEvents() 'ptla do mutacji
    Mutacja = Mutacja + 1
    If fStop = True Then
      Exit Do
    End If
  
    frmWorkUM.Mutacje = Str$(Mutacja)
    sngCzas2 = Timer
    strCzas3 = Format$(sngCzas2 - sngCzas1, "###0.0") + " second"
    frmWorkUM.InfoTime = strCzas3

    If Val(Format$(Min, "###0.00000")) > Val(frmWorkUM.lblFunkcja) Then
      Beep
      MsgBox "Error - Min invalid value"
    End If

    frmWorkUM.lblChangeM = Str$(BrakZmian)
    frmWorkUM.lblFunkcja.Caption = Format$(Min, "###0.00000") 'tu poprawi

    Counter1 = Losuj(1, Probablity)
    Counter2 = 0
    For Counter3 = 1 To 7
      Counter2 = Counter2 + PMut(Counter3)
      If Counter2 >= Counter1 Then
        TypZmiany = Counter3
        Exit For
      Else
        TypZmiany = 8
      End If
    Next
    
    Select Case TypZmiany
      Case 1  'SequenceChange
        x = Losuj(1, ArkuszHeight)
        Do
          y = Losuj(1, ArkuszHeight)
          If y <> x Then Exit Do
        Loop
        If x > y Then
          Zamienna = x
          x = y
          y = Zamienna
        End If
        i = 0
        X1 = Fix(((y - x) + 1) / 2)
        For j = x To x + X1 - 1
          Zamienna = Chromosom(2, j + i)
          Chromosom(2, j + i) = Chromosom(2, y - i)
          Chromosom(2, y - i) = Zamienna
          i = i + 1
        Next
      Case 2 'FragmentTransfer
        x = Losuj(1, ArkuszHeight)
        y = Losuj(1, Int(ArkuszHeight / 2))
        y = x + y - 1
        If y > ArkuszHeight Then y = ArkuszHeight
         
        LFrag = (y - x) + 1
        ReDim Zmienne(1 To LFrag)
        For j = x To y 'kopiuje wybrany do przenoszenia fragment
          Zmienne(j - x + 1) = Chromosom(2, j)
        Next
        If y < ArkuszHeight Then 'scala macierz po wyciciu wybranego fragmentu
          For j = y + 1 To ArkuszHeight
            Chromosom(2, x + (j - (y + 1))) = Chromosom(2, j)
          Next
        End If
        X1 = Losuj(1, ArkuszHeight - LFrag) 'wybiera miejsce wstawiania

        ReDim Zmienne2(1 To (ArkuszHeight - ((X1 - 1) + LFrag)))
        
        For j = X1 To ArkuszHeight - LFrag 'kopiuje macierz od wybranego miejsca
          Zmienne2((j - X1) + 1) = Chromosom(2, j)
        Next

        For j = X1 + LFrag To ArkuszHeight 'rozsuwa macierz wybranym miejscu
          Chromosom(2, j) = Zmienne2(j - (X1 + LFrag) + 1)
        Next

        For j = X1 To X1 + LFrag - 1     'wstawia przenoszony fragment
          Chromosom(2, j) = Zmienne(j - X1 + 1)
        Next
          
      Case 3 'SomeSingleTransfers
        X1 = Losuj(1, 19)

        For i = 1 To X1 'kilka pojedynczych przesuni
          x = Losuj(1, ArkuszHeight)
          y = Losuj(1, ArkuszHeight - 1)
          Do
            y = Losuj(1, ArkuszHeight)
            If y <> x Then Exit Do
          Loop
          Zamienna = Chromosom(2, x)
                
          If x > y Then
            For j = x To y + 1 Step -1
              Chromosom(2, j) = Chromosom(2, j - 1)
            Next
            Chromosom(2, y) = Zamienna
          End If
            
          If x < y Then
            For j = x To y - 1
              Chromosom(2, j) = Chromosom(2, j + 1)
            Next
            Chromosom(2, y) = Zamienna
          End If
        Next
          
      Case 4 'SingleTransfers
        x = Losuj(1, ArkuszHeight)
        y = Losuj(1, ArkuszHeight - 1)
        Do
          y = Losuj(1, ArkuszHeight)
          If y <> x Then Exit Do
        Loop
            
        Zamienna = Chromosom(2, x)
            
        If x > y Then
          For j = x To y + 1 Step -1
            Chromosom(2, j) = Chromosom(2, j - 1)
          Next
          Chromosom(2, y) = Zamienna
        End If
                        
        If x < y Then
          For j = x To y - 1
            Chromosom(2, j) = Chromosom(2, j + 1)
          Next
          Chromosom(2, y) = Zamienna
        End If
      Case 5 'SomeRemoteConversions
        X1 = Losuj(1, 19)
        For i = 1 To X1
          x = Losuj(1, ArkuszHeight)
          y = Losuj(1, ArkuszHeight)
          Zamienna = Chromosom(2, x)
          Chromosom(2, x) = Chromosom(2, y)
          Chromosom(2, y) = Zamienna
        Next

      Case 6 'RemoteConversion
        x = Losuj(1, ArkuszHeight)
        y = Losuj(1, ArkuszHeight)
        Zamienna = Chromosom(2, x)
        Chromosom(2, x) = Chromosom(2, y)
        Chromosom(2, y) = Zamienna
          
      Case 7 'SomeNeighbourConversion
        X1 = Losuj(1, 19)
        For j = 1 To X1
          x = Losuj(1, ArkuszHeight)
          y = x + 1
          If y > ArkuszHeight Then y = ArkuszHeight
            Zamienna = Chromosom(2, x)
            Chromosom(2, x) = Chromosom(2, y)
            Chromosom(2, y) = Zamienna
        Next
          
      Case 8 'NeighbourConversion
          x = Losuj(1, ArkuszHeight)
          y = x + 1
          If y > ArkuszHeight Then y = ArkuszHeight
          Zamienna = Chromosom(2, x)
          Chromosom(2, x) = Chromosom(2, y)
          Chromosom(2, y) = Zamienna

      End Select

    'tu sprawdzenie wartoci funkcji F0
    Funkcja(2) = 0
    TempM = 0
    For l = 1 To ArkuszHeight - 1
      For n = l + 1 To ArkuszHeight
        Funkcja(2) = Funkcja(2) + ((n - l) ^ 2) / ((Dystans2(Chromosom(2, l), Chromosom(2, n)) + 1))
      Next
    Next

    TempM = ((ArkuszHeight ^ 2) / 2)
    Funkcja(2) = Funkcja(2) / TempM

    frmWorkUM.lblActualUM = Format$(Funkcja(2), "###0.00000")
    If Funkcja(2) < Min Then
      Min = Funkcja(2)
      Winner = 2
      BrakZmian = 0
      For k = 1 To ArkuszHeight
        Pierwotny(k) = Chromosom(Winner, k)
      Next
    Else
      Winner = 1
      BrakZmian = BrakZmian + 1
      For j = 1 To ArkuszHeight
        Chromosom(1, j) = Pierwotny(j)
        Chromosom(2, j) = Pierwotny(j)
      Next
    End If
      
    If BrakZmian >= Mutation Then Exit Do

 Loop 'koniec wewntrznej ptli

    If Pokolenie = 1 Then UmGen = Min
 
    Mutacja = 0: BrakZmian = 0

    If Pokolenie > 1 Then
      If Min >= UmGen Then
        BrakZmian2 = BrakZmian2 + 1
      Else
        BrakZmian2 = 0
        UmGen = Min
        For k = 1 To ArkuszHeight
          BestPierwotny(k) = Pierwotny(k)
        Next
      End If
    End If
    frmWorkUM.BestUm.Caption = Format$(UmGen, "###0.00000")
    frmWorkUM.lblChangesG.Caption = Str$(BrakZmian2)
    If BrakZmian2 = Generation Then Exit Do
Loop

Unload frmWorkUM

For k = 1 To ArkuszHeight
   Pierwotny(k) = BestPierwotny(k)
Next

For i = 1 To ArkuszHeight
   If Not gFromMatrix Then
      For j = 1 To ArkuszWidth
         DaneMaczka(i, j) = Dane2(Pierwotny(i), j)
      Next
      RecInfo(i) = Rec3Info(Pierwotny(i))
   Else
      RecInfo(i) = MatPar(intActive).RecInfo(Pierwotny(i))
   End If
Next

If Not gFromMatrix Then
   boOblicz = ComputeMatrix(ArkuszHeight, ArkuszWidth)
   If Not boOblicz Then
      Exit Sub
   End If
Else
   For i = 1 To ArkuszHeight
      For j = 1 To ArkuszHeight
         Dystans(i, j) = MatPar(intActive).Distance(Pierwotny(i), Pierwotny(j))
      Next
   Next
End If

End If 'koniec automatycznego porzdkowania
'------------------------------------------------------------
gAnaliza = 0 'flaga do analizy

Screen.MousePointer = vbHourglass
    
'powolanie nowego obiektu DiagPar i formy Diagram
Dim fIndex As Integer
fIndex = 0
fIndex = CFindFreeIndex()
gIndex = fIndex
DiagPar(fIndex).Height = ArkuszHeight
DiagPar(fIndex).Width = ArkuszWidth
If gFromMatrix Then
   DiagPar(fIndex).MatrixOnly = True
Else
   DiagPar(fIndex).MatrixOnly = False
End If
ReDim DiagPar(fIndex).Distance(1 To ArkuszHeight, 1 To ArkuszHeight)
If Not gFromMatrix Then
   ReDim DiagPar(fIndex).Data(1 To ArkuszHeight, 1 To ArkuszWidth)
End If
If Not gFromMatrix Then
   ReDim DiagPar(fIndex).Etykiety(1 To ArkuszWidth)
End If
ReDim DiagPar(fIndex).RecInfo(1 To ArkuszHeight)
ReDim DiagPar(fIndex).Przedzial(1 To 4)
ReDim DiagPar(fIndex).Grupa(1 To ArkuszHeight, 1 To ArkuszHeight)
ReDim DiagPar(fIndex).DataRecNA(1 To ArkuszHeight)
If Not gFromMatrix Then
   DiagPar(fIndex).DistanceType = DystansType
End If
DiagPar(fIndex).RodzajDiagramu = RodzajDiagramu

'zapis macierzy odleglosci do wewnetrznej tablicy diagramu
For i = 1 To ArkuszHeight
  For j = 1 To ArkuszHeight
    DiagPar(fIndex).Distance(i, j) = Dystans(i, j)
  Next
Next

'zapis danych do wewnetrznej tablicy diagramu
If Not gFromMatrix Then
   For i = 1 To ArkuszHeight
      For j = 1 To ArkuszWidth
         DiagPar(fIndex).Data(i, j) = DaneMaczka(i, j)
      Next
   Next
End If

'zapis etykiet (nazw) cech do wewnetrznej tablicy diagramu
If Not gFromMatrix Then
   For i = 1 To ArkuszWidth
      DiagPar(fIndex).Etykiety(i) = Etykiety(i)
   Next
End If

'zapis nazw rekordw to tablicy wewnetrznej diagramu
If Not gFromMatrix Then
   For i = 1 To ArkuszHeight
      DiagPar(fIndex).RecInfo(i) = RecInfo(i)
   Next
   For i = 1 To ArkuszHeight
   'zapis informacji o niepenych danych
      DiagPar(fIndex).DataRecNA(i) = gDataRecNA(i)
   Next
Else
   For i = 1 To ArkuszHeight
      DiagPar(fIndex).RecInfo(i) = MatPar(intActive).RecInfo(i)
   Next
End If

'zapis granic przedzialow do wewnetrznej tablicy diagramu
For i = 1 To 4
  DiagPar(fIndex).Przedzial(i) = Przedzial(i)
Next

'zapis macierzy do okna
For i = 1 To ArkuszHeight
   For j = 1 To ArkuszHeight
      If DiagPar(fIndex).Distance(i, j) >= 0 And DiagPar(fIndex).Distance(i, j) < DiagPar(fIndex).Przedzial(1) Then
         DiagPar(fIndex).Grupa(i, j) = 5
      ElseIf DiagPar(fIndex).Distance(i, j) >= DiagPar(fIndex).Przedzial(1) And DiagPar(fIndex).Distance(i, j) < DiagPar(fIndex).Przedzial(2) Then
         DiagPar(fIndex).Grupa(i, j) = 4
      ElseIf DiagPar(fIndex).Distance(i, j) >= DiagPar(fIndex).Przedzial(2) And DiagPar(fIndex).Distance(i, j) < DiagPar(fIndex).Przedzial(3) Then
         DiagPar(fIndex).Grupa(i, j) = 3
      ElseIf DiagPar(fIndex).Distance(i, j) >= DiagPar(fIndex).Przedzial(3) And DiagPar(fIndex).Distance(i, j) < DiagPar(fIndex).Przedzial(4) Then
         DiagPar(fIndex).Grupa(i, j) = 2
      ElseIf DiagPar(fIndex).Distance(i, j) >= DiagPar(fIndex).Przedzial(4) Then
         DiagPar(fIndex).Grupa(i, j) = 1
      Else
         DiagPar(fIndex).Grupa(i, j) = 6
      End If
   Next
Next

Diagram(fIndex).Caption = "[DIAGRAM]: Untitled:" & fIndex
If Not gFromMatrix Then
   Diagram(fIndex).BottomText = frmMDI.ActiveForm.OpisText
Else
   Diagram(fIndex).BottomText = Macierz(intActive).BottomText
End If
Diagram(fIndex).Tag = CStr(fIndex)
Diagram(fIndex).Siatka.Cols = DiagPar(fIndex).Height + 2
Diagram(fIndex).Siatka.Rows = DiagPar(fIndex).Height + 1
Diagram(fIndex).Siatka.FontBold = False
If ArkuszHeight > 99 Then
   Diagram(fIndex).Siatka.FontSize = 7
Else
   Diagram(fIndex).Siatka.FontSize = 8
End If
    
Diagram(fIndex).Siatka.ColAlignment(1) = 0
For i = 2 To DiagPar(fIndex).Height
   Diagram(fIndex).Siatka.ColAlignment(i) = 2
Next

Diagram(fIndex).Siatka.Row = 0
For i = 2 To DiagPar(fIndex).Height + 1
   Diagram(fIndex).Siatka.Col = i
   Diagram(fIndex).Siatka.COLWIDTH(i) = 1.5 * Diagram(fIndex).picColor01.Width
   Diagram(fIndex).Siatka.RowHeight(0) = Diagram(fIndex).picColor01.Height
   Diagram(fIndex).Siatka.Text = LTrim$(RTrim$(Str$(i - 1)))
Next
    
Diagram(fIndex).Siatka.Col = 0
For i = 0 To DiagPar(fIndex).Height
   Diagram(fIndex).Siatka.Row = i
   Diagram(fIndex).Siatka.COLWIDTH(i) = 450
   Diagram(fIndex).Siatka.RowHeight(i) = Diagram(fIndex).picColor01.Height
Next

Diagram(fIndex).Siatka.Col = 0
For i = 1 To DiagPar(fIndex).Height
   Diagram(fIndex).Siatka.Row = i
   Diagram(fIndex).Siatka.COLWIDTH(i) = 1.5 * Diagram(fIndex).picColor01.Width
   Diagram(fIndex).Siatka.RowHeight(i) = Diagram(fIndex).picColor01.Height
   Diagram(fIndex).Siatka.Text = LTrim$(RTrim$(Str$(i)))
Next

Diagram(fIndex).Siatka.Col = 1
For i = 0 To DiagPar(fIndex).Height
   Diagram(fIndex).Siatka.Row = i
   Diagram(fIndex).Siatka.COLWIDTH(1) = 1800
   Diagram(fIndex).Siatka.RowHeight(i) = Diagram(fIndex).picColor01.Height
   If i = 0 Then Diagram(fIndex).Siatka.Text = "Name"
   If i >= 1 Then Diagram(fIndex).Siatka.Text = DiagPar(fIndex).RecInfo(i)
Next

For i = 1 To DiagPar(fIndex).Height
   For j = 2 To DiagPar(fIndex).Height + 1
      Diagram(fIndex).Siatka.Row = i
      Diagram(fIndex).Siatka.Col = j
      Diagram(fIndex).Siatka.COLWIDTH(j) = Diagram(fIndex).picColor01.Width
      Diagram(fIndex).Siatka.RowHeight(i) = Diagram(fIndex).picColor01.Height
      Select Case DiagPar(fIndex).Grupa(i, j - 1)
         Case 1
            Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picColor01.Picture
         Case 2
            If DiagPar(fIndex).RodzajDiagramu = 1 Then
               Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picColor02.Picture
            ElseIf DiagPar(fIndex).RodzajDiagramu = 2 Then
               If DiagPar(fIndex).DataRecNA(i) = True Or DiagPar(fIndex).DataRecNA(j - 1) = True Then
                  Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picCircle02NA.Picture
               Else
                  Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picCircle02.Picture
               End If
            ElseIf DiagPar(fIndex).RodzajDiagramu = 3 Then
               Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picClassic02.Picture
            End If
         Case 3
            If DiagPar(fIndex).RodzajDiagramu = 1 Then
               Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picColor03.Picture
            ElseIf DiagPar(fIndex).RodzajDiagramu = 2 Then
               If DiagPar(fIndex).DataRecNA(i) = True Or DiagPar(fIndex).DataRecNA(j - 1) = True Then
                  Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picCircle03NA.Picture
               Else
                  Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picCircle03.Picture
               End If
            ElseIf DiagPar(fIndex).RodzajDiagramu = 3 Then
               Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picClassic03.Picture
            End If
         Case 4
            If DiagPar(fIndex).RodzajDiagramu = 1 Then
               Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picColor04.Picture
            ElseIf DiagPar(fIndex).RodzajDiagramu = 2 Then
               If DiagPar(fIndex).DataRecNA(i) = True Or DiagPar(fIndex).DataRecNA(j - 1) = True Then
                  Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picCircle04NA.Picture
               Else
                  Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picCircle04.Picture
               End If
            ElseIf DiagPar(fIndex).RodzajDiagramu = 3 Then
               Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picClassic04.Picture
            End If
         Case 5
            If DiagPar(fIndex).RodzajDiagramu = 1 Then
               Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picColor05.Picture
            ElseIf DiagPar(fIndex).RodzajDiagramu = 2 Then
               If DiagPar(fIndex).DataRecNA(i) = True Or DiagPar(fIndex).DataRecNA(j - 1) = True Then
                  Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picCircle05NA.Picture
               Else
                  Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picCircle05.Picture
               End If
            ElseIf DiagPar(fIndex).RodzajDiagramu = 3 Then
               Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picClassic05.Picture
            End If
         Case 0
            Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picColor06.Picture
      End Select
   Next
Next

'------------
CState(fIndex).Dirty = True
Diagram(fIndex).WindowState = 0
If Diagram(fIndex).WindowState = 0 Then
   Diagram(fIndex).Width = 0.95 * Screen.Width
   Diagram(fIndex).Height = 0.8 * Screen.Height
   Diagram(fIndex).Top = 0
   Diagram(fIndex).Left = 0
End If
Diagram(fIndex).Show

' reset mouse pointer
Screen.MousePointer = vbDefault

End Sub

Sub MakeDystansTable()
If gAnaliza = 1 Then
   Beep
   Exit Sub
End If

'deklaracja zmiennych
Dim ArkuszWidth As Long, ArkuszHeight As Long
Dim i As Integer, j As Integer, k As Integer
Dim PrzekaznikOpis
Dim boOblicz As Boolean

'wczytanie danych z arkusza
ArkuszWidth = frmMDI.ActiveForm.Grid1.Cols - 2
ArkuszHeight = frmMDI.ActiveForm.Grid1.Rows - 1

If ArkuszHeight < 2 Then
   MsgBox "The number of records is less than 2. I can't create matrix!", 0 + 16
   Exit Sub
End If

If ArkuszHeight > 150 Then
   MsgBox "The number of records is > 150 (max. number of records)!", 0 + 16
   Exit Sub
End If

frmOpcjeMacierzy.Show 1
If Dalej = -99 Then Exit Sub

Err = 0 ' zerowanie bdw
PrzekaznikOpis = frmMDI.ActiveForm.OpisText

'wczytanie danych z arkusza
If Not GetDataFromGrid Then
   Exit Sub
End If

boOblicz = ComputeMatrix(ArkuszHeight, ArkuszWidth)
If Not boOblicz Then
   Exit Sub
End If

Dim Maksymalny
Maksymalny = 0
For i = 1 To ArkuszHeight
   For j = 1 To ArkuszHeight
      If Dystans(i, j) >= Maksymalny Then
         Maksymalny = Dystans(i, j)
      End If
   Next
Next

Screen.MousePointer = vbHourglass
    
' change form's caption and display new text
Dim fIndex
fIndex = 0
fIndex = MFindFreeIndex()
gIndex = fIndex
MatPar(fIndex).Height = ArkuszHeight
Macierz(fIndex).Tag = fIndex
Macierz(fIndex).Caption = "[MATRIX]: Untitled:" & fIndex
Macierz(fIndex).BottomText = PrzekaznikOpis
ReDim MatPar(fIndex).Distance(1 To ArkuszHeight, 1 To ArkuszHeight)
ReDim MatPar(fIndex).RecInfo(1 To ArkuszHeight)
'zapis macierzy odleglosci i tablicy nazw rekordw do wewnetrznej tablicy macierzy
For i = 1 To ArkuszHeight
   MatPar(fIndex).RecInfo(i) = RecInfo(i)
   For j = 1 To ArkuszHeight
      MatPar(fIndex).Distance(i, j) = Dystans(i, j)
   Next
Next

'zapis macierzy do okna
Macierz(fIndex).Siatka.Rows = ArkuszHeight + 1
Macierz(fIndex).Siatka.Cols = ArkuszHeight + 2

For i = 0 To ArkuszHeight
   Macierz(fIndex).Siatka.FixedAlignment(i) = 2
Next

Macierz(fIndex).Siatka.Col = 0
For i = 1 To ArkuszHeight
   Macierz(fIndex).Siatka.Row = i
   Macierz(fIndex).Siatka.Text = i
Next

Macierz(fIndex).Siatka.Col = 1
Macierz(fIndex).Siatka.COLWIDTH(1) = Macierz(fIndex).Siatka.COLWIDTH(1) * 3
For i = 1 To ArkuszHeight
   Macierz(fIndex).Siatka.Row = i
   Macierz(fIndex).Siatka.Text = RecInfo(i)
Next

Dim intMaksymalny As Integer
intMaksymalny = Len(CStr(Maksymalny))

Macierz(fIndex).Siatka.Row = 0
For i = 2 To ArkuszHeight + 1
   Macierz(fIndex).Siatka.Col = i
   Macierz(fIndex).Siatka.ColAlignment(i) = 1
   If intMaksymalny <= 4 Then
      Macierz(fIndex).Siatka.COLWIDTH(i) = Macierz(fIndex).Siatka.COLWIDTH(i) * 1.3
   ElseIf intMaksymalny = 5 Then
      Macierz(fIndex).Siatka.COLWIDTH(i) = Macierz(fIndex).Siatka.COLWIDTH(i) * 1.5
   ElseIf intMaksymalny = 6 Then
      Macierz(fIndex).Siatka.COLWIDTH(i) = Macierz(fIndex).Siatka.COLWIDTH(i) * 1.75
   ElseIf intMaksymalny = 7 Then
      Macierz(fIndex).Siatka.COLWIDTH(i) = Macierz(fIndex).Siatka.COLWIDTH(i) * 2
   ElseIf intMaksymalny = 8 Then
      Macierz(fIndex).Siatka.COLWIDTH(i) = Macierz(fIndex).Siatka.COLWIDTH(i) * 2.3
   ElseIf intMaksymalny = 9 Then
      Macierz(fIndex).Siatka.COLWIDTH(i) = Macierz(fIndex).Siatka.COLWIDTH(i) * 2.5
   ElseIf intMaksymalny >= 10 Then
      Macierz(fIndex).Siatka.COLWIDTH(i) = Macierz(fIndex).Siatka.COLWIDTH(i) * 2.75
   End If
   Macierz(fIndex).Siatka.Text = i - 1
Next

For i = 1 To ArkuszHeight
   For j = 2 To ArkuszHeight + 1
      Macierz(fIndex).Siatka.Row = i
      Macierz(fIndex).Siatka.Col = j
      Macierz(fIndex).Siatka.Text = Format$(Dystans(i, j - 1), "###0.000")
   Next
Next

MState(fIndex).Dirty = True
Macierz(fIndex).WindowState = 0
If Macierz(fIndex).WindowState = 0 Then
   Macierz(fIndex).Width = 0.95 * Screen.Width
   Macierz(fIndex).Height = 0.8 * Screen.Height
   Macierz(fIndex).Left = 0
   Macierz(fIndex).Top = 0
End If
Macierz(fIndex).Show

' reset mouse pointer
Screen.MousePointer = vbDefault

End Sub

Function ObliczDystans(Obiekt_A(), Obiekt_B(), ArkuszW) As Single
Dim i, j As Integer
i = 0: j = 0
Dim Suma As Single: Suma = 0:
Dim Suma1 As Long: Suma1 = 0
Dim Suma2 As Long: Suma2 = 0

Select Case DystansType
   Case 1 'Henzel DD2
      For i = 1 To ArkuszW
         If Obiekt_A(i) <> gEmpty And Obiekt_B(i) <> gEmpty Then
            Suma = Suma + (Obiekt_A(i) - Obiekt_B(i)) ^ 2
            j = j + 1
         End If
      Next
      If j = 0 Then
         ObliczDystans = 0
      Else
         ObliczDystans = Suma / j
      End If
   Case 2 'Czekanowski
      For i = 1 To ArkuszW
         If Obiekt_A(i) <> gEmpty And Obiekt_B(i) <> gEmpty Then
            Suma = Suma + Abs(Obiekt_A(i) - Obiekt_B(i))
            j = j + 1
         End If
      Next
      If j = 0 Then
         ObliczDystans = 0
      Else
         ObliczDystans = Suma / j
      End If
   Case 3 'Euclidean
      For i = 1 To ArkuszW
         Suma = Suma + (Obiekt_A(i) - Obiekt_B(i)) ^ 2
      Next
      ObliczDystans = Sqr(Suma)
   Case 4 'City-Block
      For i = 1 To ArkuszW
         Suma = Suma + Abs(Obiekt_A(i) - Obiekt_B(i))
      Next
      ObliczDystans = Suma
   Case 5 'Chebychev
      Dim Max
      Max = 0
      For i = 1 To ArkuszW
         If Abs(Obiekt_A(i) - Obiekt_B(i)) > Max Then
            Max = Abs(Obiekt_A(i) - Obiekt_B(i))
         End If
      Next
      ObliczDystans = Max
   Case 6 'Customized
      For i = 1 To ArkuszW
         Suma = Suma + Abs(Obiekt_A(i) - Obiekt_B(i)) ^ Par_P
      Next
      ObliczDystans = (Suma) ^ (1 / Par_R)
   Case 7 'Descriptive Data Distance
      For i = 1 To ArkuszW
         If Obiekt_A(i) <> Obiekt_B(i) Then
            Suma = Suma + 1
         End If
      Next
      ObliczDystans = (Suma / ArkuszW) * 100
   Case 8 'Lance and Williams
      For i = 1 To ArkuszW
         If Obiekt_A(i) <> Obiekt_B(i) Then
            Suma = Suma + 1
         End If
         If Obiekt_A(i) = 0 And Obiekt_B(i) = 0 Then
            Suma1 = Suma1 + 1
         End If
      Next
      ObliczDystans = (Suma / ((2 * Suma1) + Suma)) '* 100
   Case 9 'Jaccard mirror
      For i = 1 To ArkuszW
         If Obiekt_A(i) <> Obiekt_B(i) Then
            Suma = Suma + 1
         End If
         If Obiekt_A(i) = 1 And Obiekt_B(i) = 1 Then
            Suma1 = Suma1 + 1
         End If
      Next
      ObliczDystans = (1 - (Suma1 / (Suma1 + Suma))) '* 100
   Case 10 'Yule's Q mirror (1 - Yq)
      Dim intA As Integer, intB As Integer, intC As Integer, intD As Integer
      Dim sMianownik As Single
      intA = 0: intB = 0: intC = 0: intD = 0
      For i = 1 To ArkuszW
         If Obiekt_A(i) = 0 And Obiekt_B(i) = 0 Then
            intA = intA + 1
         End If
         If Obiekt_A(i) = 1 And Obiekt_B(i) = 1 Then
            intD = intD + 1
         End If
         If Obiekt_A(i) = 1 And Obiekt_B(i) = 0 Then
            intC = intC + 1
         End If
         If Obiekt_A(i) = 0 And Obiekt_B(i) = 1 Then
            intB = intB + 1
         End If
      Next
      sMianownik = ((intA * intD) + (intB * intC))
      If sMianownik > 0 Then
         ObliczDystans = 1 - (((intA * intD) - (intB * intC)) / sMianownik)
      Else
         ObliczDystans = 1 - (-1)
      End If
   End Select
End Function

Sub OptionsToolbarProc(CurrentForm As Form)
CurrentForm.mnuOToolbar.Checked = Not CurrentForm.mnuOToolbar.Checked
If TypeOf CurrentForm Is MDIForm Then
Else
   frmMDI.mnuOToolbar.Checked = CurrentForm.mnuOToolbar.Checked
End If
If CurrentForm.mnuOToolbar.Checked Then
   frmMDI.toolMain.Visible = True
Else
   frmMDI.toolMain.Visible = False
End If
End Sub

Sub ShowAboutWindow()
If gAnaliza = 1 Then
   Beep
   Exit Sub
End If

frmAbout.Show vbModal

End Sub

Sub Standarization()
If gAnaliza = 1 Then
   Beep
   Exit Sub
End If

'wczytanie danych z arkusza
Dim ArkuszWidth As Long, ArkuszHeight As Long
Dim i As Integer, j As Integer, k As Integer
Dim PrzekaznikOpis
Dim Konwersja, ZmiennaKonwersji, Litera

frmMDI.ActiveForm.Grid1.SetFocus
Err = 0 ' zerowanie bdw

ArkuszWidth = frmMDI.ActiveForm.Grid1.Cols - 2
ArkuszHeight = frmMDI.ActiveForm.Grid1.Rows - 1

If ArkuszHeight < 2 Then
   MsgBox "The number of records is less than 2. How make standarization?", 0 + 16
   Exit Sub
End If

frmStandard.Show vbModal
frmStandard.Refresh
If Dalej = -99 Then Exit Sub

Screen.MousePointer = vbHourglass

frmMDI.ActiveForm.Grid1.SetFocus
frmMDI.ActiveForm.Grid1.Col = 2
frmMDI.ActiveForm.Grid1.Row = 1

ReDim RecInfo(1 To ArkuszHeight)
ReDim DaneMaczka(1 To ArkuszHeight, 1 To ArkuszWidth)
ReDim Etykiety(1 To ArkuszWidth)
ReDim Dys_S(1 To ArkuszHeight)
ReDim Dys_P(1 To ArkuszHeight)
ReDim Grupa(1 To ArkuszHeight, 1 To ArkuszHeight)

PrzekaznikOpis = frmMDI.ActiveForm.OpisText

'wczytanie nazw rekordw
frmMDI.ActiveForm.Grid1.Col = 1
For i = 1 To ArkuszHeight
 frmMDI.ActiveForm.Grid1.Row = i
 RecInfo(i) = LTrim$(RTrim$(frmMDI.ActiveForm.Grid1.Text))
Next

'wczytanie nazw etykiet
frmMDI.ActiveForm.Grid1.Row = 0
For i = 2 To ArkuszWidth + 1
 frmMDI.ActiveForm.Grid1.Col = i
 Etykiety(i - 1) = LTrim$(RTrim$(frmMDI.ActiveForm.Grid1.Text))
Next

'wczytanie danych
For i = 1 To ArkuszHeight
   frmMDI.ActiveForm.Grid1.Row = i
   For j = 1 To ArkuszWidth
      frmMDI.ActiveForm.Grid1.Col = j + 1
  
      'konwersja danych jeli system Windows ma ustawiony separator jako przecinek
      Dim strTemp As String
      strTemp = Replace$(frmMDI.ActiveForm.Grid1.Text, ",", ".")
      DaneMaczka(i, j) = Val(LTrim$(RTrim$(strTemp)))

      If Err Then
         MsgBox "Data Error. Row=" + Str$(i) + ", Col=" + Str$(j), 0 + 16
         Screen.MousePointer = vbDefault
         Exit Sub
      End If
      If LTrim$(RTrim$(frmMDI.ActiveForm.Grid1.Text)) = "" Then
         frmMDI.ActiveForm.Grid1.Text = "0.0"
      End If
   Next
Next

If TypStandard = 1 Then
   ReDim Suma(1 To ArkuszWidth)
   ReDim SumaKwadrat(1 To ArkuszWidth)
   ReDim Average(1 To ArkuszWidth)
   ReDim Wariancja(1 To ArkuszWidth)
   ReDim Standard(1 To ArkuszWidth)

   For i = 1 To ArkuszWidth
      For j = 1 To ArkuszHeight
         Suma(i) = Suma(i) + DaneMaczka(j, i)
      Next
      Average(i) = Suma(i) / ArkuszHeight
   Next

   For i = 1 To ArkuszWidth
      For j = 1 To ArkuszHeight
         SumaKwadrat(i) = SumaKwadrat(i) + (DaneMaczka(j, i) - Average(i)) ^ 2
      Next
   Next
   
   For i = 1 To ArkuszWidth
      Wariancja(i) = SumaKwadrat(i) / (ArkuszHeight - 1)
      Standard(i) = Sqr(Wariancja(i))
   Next
 
   For i = 1 To ArkuszWidth
      For j = 1 To ArkuszHeight
         DaneMaczka(j, i) = (DaneMaczka(j, i) - Average(i)) / Standard(i)
      Next
   Next

ElseIf TypStandard = 2 Then

   ReDim Max(1 To ArkuszWidth)
   ReDim Min(1 To ArkuszWidth)
 
   For i = 1 To ArkuszWidth
      Min(i) = DaneMaczka(1, i)
      Max(i) = DaneMaczka(1, i)
      For j = 1 To ArkuszHeight
         If DaneMaczka(j, i) > Max(i) Then
            Max(i) = DaneMaczka(j, i)
         End If
         If DaneMaczka(j, i) < Min(i) Then
            Min(i) = DaneMaczka(j, i)
         End If
      Next
   Next

   Dim Factor As Integer
   Factor = 100

   For i = 1 To ArkuszWidth
      For j = 1 To ArkuszHeight
         If Max(i) = Min(i) Then
            MsgBox "Invalid data - variable number 2 is always the same!"
         Else
            DaneMaczka(j, i) = ((DaneMaczka(j, i) - Min(i)) / (Max(i) - Min(i))) * Factor
         End If
      Next
   Next

End If

Dim fIndex As Integer

'change form's caption and display new data
fIndex = FindFreeIndex()
document(fIndex).Tag = fIndex
document(fIndex).Caption = "[DATA]: Untitled:" & fIndex
document(fIndex).OpisText = "STANDARD: " & LTrim$(RTrim$(PrzekaznikOpis))

'Just some code to make the grid interesting
document(fIndex).Grid1.Cols = ArkuszWidth + 2 'plus dwa poniewa dochodzi kolumna na etykiety
document(fIndex).Grid1.Rows = ArkuszHeight + 1 'plus dwa poniewa dochodzi wiersz gowny z nazwami cech

document(fIndex).Grid1.Row = 0
document(fIndex).Grid1.Col = 0
document(fIndex).Grid1.Text = "Number"

document(fIndex).Grid1.Col = 0
document(fIndex).Grid1.COLWIDTH(0) = 900
Dim JakaSzer, x%, y%
JakaSzer = 900

For x% = 1 To document(fIndex).Grid1.Rows - 1
  document(fIndex).Grid1.Row = x%
  document(fIndex).Grid1.Text = Str$(x%) 'numery wierszy z rekordami
Next x%

document(fIndex).Grid1.FixedAlignment(0) = 2 'wyrodkowanie numerw

document(fIndex).Grid1.Row = 0
For x% = 1 To document(fIndex).Grid1.Cols - 1
  If x% = 1 Then
    document(fIndex).Grid1.COLWIDTH(x%) = 1800
    JakaSzer = JakaSzer + 1800
    document(fIndex).Grid1.FixedAlignment(x%) = 0      'left aligned
    document(fIndex).Grid1.ColAlignment(x%) = 0      'left aligned
  Else
    document(fIndex).Grid1.COLWIDTH(x%) = 900
    JakaSzer = JakaSzer + 900
    document(fIndex).Grid1.FixedAlignment(x%) = 1      'right aligned
    document(fIndex).Grid1.ColAlignment(x%) = 1      'right aligned
  End If
  document(fIndex).Grid1.Col = x%
  If x% = 1 Then
    document(fIndex).Grid1.Text = "Record Name"
  Else
    document(fIndex).Grid1.Text = Etykiety(x% - 1)
  End If
  Next x%

  document(fIndex).Grid1.Col = 0
  For i = 1 To document(fIndex).Grid1.Cols - 1
    document(fIndex).Grid1.FixedAlignment(i) = 2
  Next

  document(fIndex).Grid1.Row = 1
  document(fIndex).Grid1.Col = 1
  For x% = 1 To document(fIndex).Grid1.Rows - 1
    document(fIndex).Grid1.Row = x%
    document(fIndex).Grid1.Text = RecInfo(x%)
  Next x%

  'deklaracja formatu wprowadzanych danych
  Dim Fmt$
  Fmt$ = "###0.000"

  For x% = 1 To document(fIndex).Grid1.Rows - 1
    For y% = 2 To document(fIndex).Grid1.Cols - 1
      document(fIndex).Grid1.Row = x%
      document(fIndex).Grid1.Col = y%
      document(fIndex).Grid1.Text = Format$(DaneMaczka(x%, y% - 1), Fmt$)
    Next
  Next

  document(fIndex).Grid1.Visible = True
  document(fIndex).TopPanel.Visible = True
  document(fIndex).Grid1.Row = 1
  document(fIndex).Grid1.Col = 1
  document(fIndex).Grid1.SetFocus
  document(fIndex).SzerOkno = JakaSzer
  document(fIndex).Grid1.SetFocus
  FState(fIndex).Dirty = True
  document(fIndex).WindowState = 0
  document(fIndex).Width = 0.95 * Screen.Width
  document(fIndex).Height = 0.8 * Screen.Height
  document(fIndex).Left = 0
  document(fIndex).Top = 0
  document(fIndex).Show
    
  GetRecentFiles
  Screen.MousePointer = vbDefault

End Sub

Sub WriteRecentFiles(OPENFILENAME)
' This procedure uses the SaveSettings statement to write the names of
' recently opened files to the System registry. The SaveSetting
' statement requires three parameters. Two of the parameters are
' stored as constants and are defined in this module.  The GetAllSettings
' function is used in the GetRecentFiles procedure to retrieve the
' file names stored in this procedure.
    
Dim i As Integer, j As Integer
Dim strFile As String, key As String

  ' Copy RecentFile1 to RecentFile2, and so on.
For i = 3 To 1 Step -1
   key = "RecentFile" & CStr(i)
   strFile = GetSetting(ThisApp, ThisKey, key)
   If strFile <> "" Then
      key = "RecentFile" & (i + 1)
      SaveSetting ThisApp, ThisKey, key, strFile
   End If
Next i
  
' Write the open file to first recent file.
SaveSetting ThisApp, ThisKey, "RecentFile1", OPENFILENAME

End Sub

Public Function ComputeMatrix(ArkuszHeight As Long, ArkuszWidth As Long) As Boolean
'obliczenie macierzy odlegoci
Dim BrakDanych As Integer
Dim i As Long, j As Long, k As Long

ReDim Dystans(1 To ArkuszHeight, 1 To ArkuszHeight)
ReDim Obiekt_A(1 To ArkuszWidth)
ReDim Obiekt_B(1 To ArkuszWidth)

Screen.MousePointer = 11

For i = 1 To ArkuszHeight
 For j = 1 To ArkuszHeight
   For k = 1 To ArkuszWidth
     Obiekt_A(k) = DaneMaczka(i, k)
     Obiekt_B(k) = DaneMaczka(j, k)
   Next
   If i = j Then
     Dystans(i, j) = 0
   ElseIf i < j Then
     BrakDanych = 0
     Dystans(i, j) = ObliczDystans(Obiekt_A(), Obiekt_B(), ArkuszWidth)
     If BrakDanych = 1 Then
       MsgBox "Empty record in data!"
       BrakDanych = 0
       ComputeMatrix = False
       Exit Function
     End If
   Else
     Dystans(i, j) = Dystans(j, i)
   End If
 Next
Next

' reset mouse pointer
Screen.MousePointer = vbDefault

ComputeMatrix = True

End Function

Public Function GetDataFromGrid() As Boolean
Dim ArkuszWidth As Long, ArkuszHeight As Long
Dim i As Integer, j As Integer, k As Integer

'poczatek wczytywania danych
ArkuszWidth = frmMDI.ActiveForm.Grid1.Cols - 2
ArkuszHeight = frmMDI.ActiveForm.Grid1.Rows - 1

frmMDI.ActiveForm.Grid1.SetFocus
frmMDI.ActiveForm.Grid1.Col = 2
frmMDI.ActiveForm.Grid1.Row = 1

ReDim RecInfo(1 To ArkuszHeight)
ReDim DaneMaczka(1 To ArkuszHeight, 1 To ArkuszWidth)
ReDim gDataRecNA(1 To ArkuszHeight)
ReDim Etykiety(1 To ArkuszWidth)

'wczytanie nazw rekordw
frmMDI.ActiveForm.Grid1.Col = 1
For i = 1 To ArkuszHeight
   frmMDI.ActiveForm.Grid1.Row = i
   RecInfo(i) = LTrim$(RTrim$(frmMDI.ActiveForm.Grid1.Text))
Next

'wczytanie nazw etykiet
frmMDI.ActiveForm.Grid1.Row = 0
For i = 2 To ArkuszWidth + 1
   frmMDI.ActiveForm.Grid1.Col = i
   Etykiety(i - 1) = LTrim$(RTrim$(frmMDI.ActiveForm.Grid1.Text))
Next

Dim strTemp As String
gDataNA = False

'wczytanie danych
For i = 1 To ArkuszHeight
   frmMDI.ActiveForm.Grid1.Row = i
   gDataRecNA(i) = False
   For j = 1 To ArkuszWidth
      frmMDI.ActiveForm.Grid1.Col = j + 1

      'konwersja danych jeli system Windows ma ustawiony separator jako przecinek
      strTemp = Replace$(frmMDI.ActiveForm.Grid1.Text, ",", ".")
      If Trim$(strTemp) <> "N/A" Then
         DaneMaczka(i, j) = Val(LTrim$(RTrim$(strTemp)))
      Else
         DaneMaczka(i, j) = gEmpty
         gDataRecNA(i) = True
         gDataNA = True
      End If

      If Err Then
         MsgBox "Data Error. Row=" + Str$(i) + ", Col=" + Str$(j), 0 + 16
         GetDataFromGrid = False
         Exit Function
      End If
  
      If LTrim$(RTrim$(frmMDI.ActiveForm.Grid1.Text)) = "" Then
         frmMDI.ActiveForm.Grid1.Text = "0.00"
      End If
   Next
Next

GetDataFromGrid = True

End Function

Public Sub ReComputeMatrix(upPierwotny() As Integer, upIndex As Integer)
'************************************************************
'Procedura ReComputeMatrix zmienia uporzadkowanie diagramu wedlug aktualnej
'kolejnosci w tabeli Pierwotny
'************************************************************
Dim temp_Dystans() As Single
Dim temp_RecInfo() As String
ReDim temp_Dystans(1 To DiagPar(upIndex).Height, 1 To DiagPar(upIndex).Height) As Single
ReDim temp_RecInfo(1 To DiagPar(upIndex).Height) As String
Dim i As Integer, j As Integer

'zamiana kolejnosci wedlug N_Order
For i = 1 To DiagPar(upIndex).Height
  For j = 1 To DiagPar(upIndex).Height
    temp_Dystans(i, j) = DiagPar(upIndex).Distance(upPierwotny(i), upPierwotny(j))
  Next
Next

For i = 1 To DiagPar(upIndex).Height
  For j = 1 To DiagPar(upIndex).Height
    DiagPar(upIndex).Distance(i, j) = temp_Dystans(i, j)
  Next
Next

For i = 1 To DiagPar(upIndex).Height
  temp_RecInfo(i) = DiagPar(upIndex).RecInfo(upPierwotny(i))
Next

For i = 1 To DiagPar(upIndex).Height
  DiagPar(upIndex).RecInfo(i) = temp_RecInfo(i)
Next

End Sub


Public Sub MakeDiagramFromMatrix()
If gAnaliza = 1 Then
  Beep
  Exit Sub
End If

Dim ArkuszWidth As Long, ArkuszHeight As Long
Dim i As Integer, j As Integer, k As Integer
'Dim IleGruppen 'PrzekaznikOpis
Dim boOblicz As Boolean

'frmMDI.ActiveForm.Grid1.SetFocus
Err = 0 ' zerowanie bdw

'ArkuszWidth = frmMDI.ActiveForm.Grid1.Cols - 2
'ArkuszHeight = frmMDI.ActiveForm.Grid1.Rows - 1

ArkuszHeight = MatPar(gIndex).Height

'If ArkuszHeight < 2 Then
'  MsgBox "The number of records is less than 2. How make diagram?", 0 + 16
'  Exit Sub
'End If

'If ArkuszHeight > gMaxObject Then
'  MsgBox "The number of records is more than " & CStr(gMaxObject) & "!", 0 + 16
'  Exit Sub
'End If

'Call CenterForm(frmMDI, frmPrzedzal)
frmPrzedzal.Show vbModal
If Dalej = -99 Then Exit Sub

'PrzekaznikOpis = frmMDI.ActiveForm.OpisText

'wczytanie danych z arkusza
'If Not GetDataFromGrid Then
'  Exit Sub
'End If

gAnaliza = 1 'flaga do analizy

ReDim Grupa(1 To ArkuszHeight, 1 To ArkuszHeight)
ReDim Dys_S(1 To ArkuszHeight)
ReDim Dys_P(1 To ArkuszHeight)

'obliczenie macierzy odlegoci
'boOblicz = ComputeMatrix(ArkuszHeight, ArkuszWidth)
'If Not boOblicz Then
'  Exit Sub
'End If

ReDim Dystans2(1 To ArkuszHeight, 1 To ArkuszHeight) As Byte
ReDim Wy(1 To ArkuszHeight)
ReDim Kolejka(1 To ArkuszHeight)
ArkuszWidth = 1
ReDim Dane2(1 To ArkuszHeight, 1 To ArkuszWidth)
ReDim Rec3Info(1 To ArkuszHeight)
Dim Minimalny, Bliski

'For i = 1 To ArkuszHeight
'  For j = 1 To ArkuszWidth
'    Dane2(i, j) = DaneMaczka(i, j)
'  Next
'Next

'For i = 1 To ArkuszHeight
'  Rec3Info(i) = RecInfo(i)
'Next

Dim Maksymalny
Maksymalny = 0
For i = 1 To ArkuszHeight
  For j = 1 To ArkuszHeight
    If MatPar(gIndex).Distance(i, j) >= Maksymalny Then
      Maksymalny = MatPar(gIndex).Distance(i, j)
    End If
  Next
Next

Dim x, y, Zamienna, UmGen, m, LiczbaZmian
Dim Procent, MinF
Dim Winner
Dim Min As Variant
Dim Czas1, Czas2, Czas3
Dim l, n, TypZmiany, BrakZmian
Dim success%

If OrderType = 3 Then
  ReDim Chromosom(1 To NumberChromo, 1 To ArkuszHeight)
  ReDim Pierwotny(1 To ArkuszHeight)
  ReDim Funkcja(1 To NumberChromo)
End If

If OrderType = 4 Then
  ReDim Chromosom(1 To 2, 1 To ArkuszHeight)
  ReDim Pierwotny(1 To ArkuszHeight)
  ReDim BestPierwotny(1 To ArkuszHeight)
  ReDim Funkcja(1 To 2)
End If

'porzdkowanie automatyczne jeli OrderType>1
If OrderType = 2 Then
    Wy(1) = 1: Kolejka(1) = 1
    k = 1: i = 1

    Do
    Minimalny = Maksymalny
      For j = 1 To ArkuszHeight
        If MatPar(gIndex).Distance(i, j) <= Minimalny And Wy(j) <> 1 Then
          Minimalny = MatPar(gIndex).Distance(i, j)
          Bliski = j
        End If
      Next
      k = k + 1
      Kolejka(k) = Bliski
      i = Bliski
      Wy(Bliski) = 1
      If k = ArkuszHeight Then Exit Do
    Loop

    'For i = 1 To ArkuszHeight
    '  For j = 1 To ArkuszWidth
    '    DaneMaczka(i, j) = Dane2(Kolejka(i), j)
    '  Next
    '  RecInfo(i) = Rec3Info(Kolejka(i))
    'Next
    
    'boOblicz = ComputeMatrix(ArkuszHeight, ArkuszWidth)
    'If Not boOblicz Then
    '  Exit Sub
    'End If
    
ElseIf OrderType = 3 Then 'porzdkowanie genetyczne
    frmWork.Show
    'success% = SetWindowPos(frmWork.hWnd, HWND_TOPMOST, 0, 0, 0, 0, Flags)
    'success% <> 0 When Successful

    fStop = False
    k = 1: i = 1
    m = 0
    LiczbaZmian = Int(ArkuszHeight / 10)
    If LiczbaZmian < 1 Then LiczbaZmian = 1

    For i = 1 To ArkuszHeight
      Pierwotny(i) = i
    Next

    Czas1 = Timer

  Do While DoEvents()
  
    If fStop = True Then
      fStop = False
      Exit Do
    End If

    m = m + 1
    Czas2 = Timer
    Czas3 = Format$(Czas2 - Czas1, "###0.0") + " second"
    Procent = Int((m / MaxMutacja) * 100)
    frmWork.InfoTime = Czas3
    frmWork.InfoString = LTrim$(Str$(Procent)) + " %" 'info string
    frmWork.lblFunkcja = Format$(MinF, "###0.000") 'tu poprawi
    frmWork.Procent1.Width = (Procent / 100) * frmWork.Procent.Width

    For i = 1 To NumberChromo
      For j = 1 To ArkuszHeight
        If m = 1 And i = 1 Then
          Chromosom(i, j) = Pierwotny(j)
        Else
          For k = 1 To ArkuszHeight
            Chromosom(i, k) = Pierwotny(k)
          Next
          If i > 1 Then 'pierwszy chromosom bez zmian
            For k = 1 To LiczbaZmian
              TypZmiany = Losuj(1, 2) '1 zmiana dowolna , 2 zmiana bliska
              If TypZmiany = 1 Then
                x = Losuj(1, ArkuszHeight)
                y = Losuj(1, ArkuszHeight)
              ElseIf TypZmiany = 2 Then
                x = Losuj(2, ArkuszHeight - 1)
                y = Losuj(x - 1, x + 1)
              End If
              Zamienna = Chromosom(i, x)
              Chromosom(i, x) = Chromosom(i, y)
              Chromosom(i, y) = Zamienna
            Next
          End If
        End If
      Next
    Next

    'tu sprawdzenie wartoci funkcji F0
    For k = 1 To NumberChromo
      Funkcja(k) = 0
    Next
    
    For k = 1 To NumberChromo
      For l = 1 To ArkuszHeight - 1
        For n = l + 1 To ArkuszHeight
          Funkcja(k) = Funkcja(k) + ((n - l) ^ 2) / ((Dystans(Chromosom(k, l), Chromosom(k, n)) + 1))
        Next
      Next
      Funkcja(k) = Funkcja(k) / ((ArkuszHeight ^ 2) / 2)
    Next

    Min = Funkcja(1): Winner = 1

    For k = 1 To NumberChromo
      If Funkcja(k) < Min Then
        Min = Funkcja(k)
        Winner = k
      End If
    Next

    MinF = Funkcja(Winner)

    For k = 1 To ArkuszHeight
      Pierwotny(k) = Chromosom(Winner, k)
    Next
 
    If m = MaxMutacja Then Exit Do
  Loop

    frmWork.InfoString = LTrim$(Str$(100)) + " %" 'info string
    Unload frmWork

    For i = 1 To ArkuszHeight
      For j = 1 To ArkuszWidth
        DaneMaczka(i, j) = Dane2(Pierwotny(i), j)
      Next
      RecInfo(i) = Rec3Info(Pierwotny(i))
    Next

   boOblicz = ComputeMatrix(ArkuszHeight, ArkuszWidth)
   If Not boOblicz Then
     Exit Sub
   End If
   
'-------------------------------------'''''----------------------
ElseIf OrderType = 4 Then 'porzdkowanie genetyczne UMCzek
    frmWorkUM.Show
    'success% = SetWindowPos(frmWorkUM.hWnd, HWND_TOPMOST, 0, 0, 0, 0, Flags)
 
    fStop = False

    'konwersja macierzy
    Dim Btemp
    If MatrixCC <> 0 Then
      For i = 1 To ArkuszHeight
        For j = 1 To ArkuszHeight
          If Dystans(i, j) > 255 Then Btemp = 255 Else Btemp = Dystans(i, j)
          Dystans2(i, j) = CByte(Btemp * MatrixCC)
        Next
      Next
    End If

    k = 1: i = 1
 
    For i = 1 To ArkuszHeight
      Pierwotny(i) = i
      BestPierwotny(i) = i
    Next
 
    Dim X1, LFrag, BrakZmian2, Pokolenie, Mutacja
    Dim PMut(1 To 8) As Integer
    Dim Counter1 As Integer, Counter2 As Integer, Counter3 As Integer
    
    PMut(1) = SequenceChange
    PMut(2) = FragmentTransfer
    PMut(3) = SomeSingleTransfers
    PMut(4) = SingleTransfers
    PMut(5) = SomeRemoteConversions
    PMut(6) = RemoteConversion
    PMut(7) = SomeNeighbourConversion
    PMut(8) = NeighbourConversion
    
    For i = 1 To 8
      Probablity = Probablity + PMut(i)
    Next
  
    Pokolenie = 0: Mutacja = 0: UmGen = 0
    Czas1 = Timer
    
    For j = 1 To ArkuszHeight
      Chromosom(1, j) = j
      Chromosom(2, j) = j
    Next

  Do While DoEvents() 'gwna ptla
    Pokolenie = Pokolenie + 1
    If fStop = True Then
      'fStop = False
      Exit Do
    End If

    frmWorkUM.Generacje = Str$(Pokolenie)
    frmWorkUM.lblFunkcja.Caption = ""
  
    For j = 1 To ArkuszHeight
      Chromosom(1, j) = BestPierwotny(j)
      Chromosom(2, j) = BestPierwotny(j)
    Next
    
    'losowy porzadek jesli kolejne pokolenie
    Dim Stemp As Integer
    
    If Pokolenie > 1 Then
      For Stemp = 1 To 500
        X1 = Losuj(1, 20)
        For i = 1 To X1 'kilka pojedynczych przesuni
          x = Losuj(1, ArkuszHeight)
          y = Losuj(1, ArkuszHeight)
          Do
            y = Losuj(1, ArkuszHeight)
            If y <> x Then Exit Do
          Loop
          Zamienna = Chromosom(2, x)
          If x > y Then
            For j = x To y + 1 Step -1
              Chromosom(2, j) = Chromosom(2, j - 1)
            Next
            Chromosom(2, y) = Zamienna
          End If
          If x < y Then
            For j = x To y - 1
              Chromosom(2, j) = Chromosom(2, j + 1)
            Next
            Chromosom(2, y) = Zamienna
          End If
        Next 'do i
      Next 'do j
    End If
    
    Dim TempM
    Min = 0
    For l = 1 To ArkuszHeight - 1
      For n = l + 1 To ArkuszHeight
        'tu zmienilem tablice Dystans na Dystans2
        Min = Min + ((Chromosom(1, n) - Chromosom(1, l)) ^ 2) / (Dystans2(Chromosom(1, l), Chromosom(1, n)) + 1)
      Next
    Next
    TempM = 0
    TempM = ((ArkuszHeight ^ 2) / 2)
    Min = Min / TempM
    frmWorkUM.lblFunkcja.Caption = Format$(Min, "###0.00000") 'tu poprawi

 Do While DoEvents() 'ptla do mutacji
    Mutacja = Mutacja + 1
    If fStop = True Then
      Exit Do
    End If
  
    frmWorkUM.Mutacje = Str$(Mutacja)
    Czas2 = Timer
    Czas3 = Format$(Czas2 - Czas1, "###0.0") + " second"
    frmWorkUM.InfoTime = Czas3

    If Val(Format$(Min, "###0.00000")) > Val(frmWorkUM.lblFunkcja) Then
      Beep
      MsgBox "Error - Min invalid value"
    End If

    frmWorkUM.lblChangeM = Str$(BrakZmian)
    frmWorkUM.lblFunkcja.Caption = Format$(Min, "###0.00000") 'tu poprawi

    Counter1 = Losuj(1, Probablity)
    Counter2 = 0
    For Counter3 = 1 To 7
      Counter2 = Counter2 + PMut(Counter3)
      If Counter2 >= Counter1 Then
        TypZmiany = Counter3
        Exit For
      Else
        TypZmiany = 8
      End If
    Next
    
    Select Case TypZmiany
      Case 1  'SequenceChange
        x = Losuj(1, ArkuszHeight)
        Do
          y = Losuj(1, ArkuszHeight)
          If y <> x Then Exit Do
        Loop
        If x > y Then
          Zamienna = x
          x = y
          y = Zamienna
        End If
        i = 0
        X1 = Fix(((y - x) + 1) / 2)
        For j = x To x + X1 - 1
          Zamienna = Chromosom(2, j + i)
          Chromosom(2, j + i) = Chromosom(2, y - i)
          Chromosom(2, y - i) = Zamienna
          i = i + 1
        Next
      Case 2 'FragmentTransfer
        x = Losuj(1, ArkuszHeight)
        y = Losuj(1, Int(ArkuszHeight / 2))
        y = x + y - 1
        If y > ArkuszHeight Then y = ArkuszHeight
         
        LFrag = (y - x) + 1
        ReDim Zmienne(1 To LFrag)
        For j = x To y 'kopiuje wybrany do przenoszenia fragment
          Zmienne(j - x + 1) = Chromosom(2, j)
        Next
        If y < ArkuszHeight Then 'scala macierz po wyciciu wybranego fragmentu
          For j = y + 1 To ArkuszHeight
            Chromosom(2, x + (j - (y + 1))) = Chromosom(2, j)
          Next
        End If
        X1 = Losuj(1, ArkuszHeight - LFrag) 'wybiera miejsce wstawiania

        ReDim Zmienne2(1 To (ArkuszHeight - ((X1 - 1) + LFrag)))
        
        For j = X1 To ArkuszHeight - LFrag 'kopiuje macierz od wybranego miejsca
          Zmienne2((j - X1) + 1) = Chromosom(2, j)
        Next

        For j = X1 + LFrag To ArkuszHeight 'rozsuwa macierz wybranym miejscu
          Chromosom(2, j) = Zmienne2(j - (X1 + LFrag) + 1)
        Next

        For j = X1 To X1 + LFrag - 1     'wstawia przenoszony fragment
          Chromosom(2, j) = Zmienne(j - X1 + 1)
        Next
          
      Case 3 'SomeSingleTransfers
        X1 = Losuj(1, 19)

        For i = 1 To X1 'kilka pojedynczych przesuni
          x = Losuj(1, ArkuszHeight)
          y = Losuj(1, ArkuszHeight - 1)
          Do
            y = Losuj(1, ArkuszHeight)
            If y <> x Then Exit Do
          Loop
          Zamienna = Chromosom(2, x)
                
          If x > y Then
            For j = x To y + 1 Step -1
              Chromosom(2, j) = Chromosom(2, j - 1)
            Next
            Chromosom(2, y) = Zamienna
          End If
            
          If x < y Then
            For j = x To y - 1
              Chromosom(2, j) = Chromosom(2, j + 1)
            Next
            Chromosom(2, y) = Zamienna
          End If
        Next
          
      Case 4 'SingleTransfers
        x = Losuj(1, ArkuszHeight)
        y = Losuj(1, ArkuszHeight - 1)
        Do
          y = Losuj(1, ArkuszHeight)
          If y <> x Then Exit Do
        Loop
            
        Zamienna = Chromosom(2, x)
            
        If x > y Then
          For j = x To y + 1 Step -1
            Chromosom(2, j) = Chromosom(2, j - 1)
          Next
          Chromosom(2, y) = Zamienna
        End If
                        
        If x < y Then
          For j = x To y - 1
            Chromosom(2, j) = Chromosom(2, j + 1)
          Next
          Chromosom(2, y) = Zamienna
        End If
      Case 5 'SomeRemoteConversions
        X1 = Losuj(1, 19)
        For i = 1 To X1
          x = Losuj(1, ArkuszHeight)
          y = Losuj(1, ArkuszHeight)
          Zamienna = Chromosom(2, x)
          Chromosom(2, x) = Chromosom(2, y)
          Chromosom(2, y) = Zamienna
        Next

      Case 6 'RemoteConversion
        x = Losuj(1, ArkuszHeight)
        y = Losuj(1, ArkuszHeight)
        Zamienna = Chromosom(2, x)
        Chromosom(2, x) = Chromosom(2, y)
        Chromosom(2, y) = Zamienna
          
      Case 7 'SomeNeighbourConversion
        X1 = Losuj(1, 19)
        For j = 1 To X1
          x = Losuj(1, ArkuszHeight)
          y = x + 1
          If y > ArkuszHeight Then y = ArkuszHeight
            Zamienna = Chromosom(2, x)
            Chromosom(2, x) = Chromosom(2, y)
            Chromosom(2, y) = Zamienna
        Next
          
      Case 8 'NeighbourConversion
          x = Losuj(1, ArkuszHeight)
          y = x + 1
          If y > ArkuszHeight Then y = ArkuszHeight
          Zamienna = Chromosom(2, x)
          Chromosom(2, x) = Chromosom(2, y)
          Chromosom(2, y) = Zamienna

      End Select

    'tu sprawdzenie wartoci funkcji F0
    Funkcja(2) = 0
    TempM = 0
    For l = 1 To ArkuszHeight - 1
      For n = l + 1 To ArkuszHeight
        Funkcja(2) = Funkcja(2) + ((n - l) ^ 2) / ((Dystans2(Chromosom(2, l), Chromosom(2, n)) + 1))
      Next
    Next

    TempM = ((ArkuszHeight ^ 2) / 2)
    Funkcja(2) = Funkcja(2) / TempM

    frmWorkUM.lblActualUM = Format$(Funkcja(2), "###0.00000")
    If Funkcja(2) < Min Then
      Min = Funkcja(2)
      Winner = 2
      BrakZmian = 0
      For k = 1 To ArkuszHeight
        Pierwotny(k) = Chromosom(Winner, k)
      Next
    Else
      Winner = 1
      BrakZmian = BrakZmian + 1
      For j = 1 To ArkuszHeight
        Chromosom(1, j) = Pierwotny(j)
        Chromosom(2, j) = Pierwotny(j)
      Next
    End If
      
    If BrakZmian >= Mutation Then Exit Do

 Loop 'koniec wewntrznej ptli

    If Pokolenie = 1 Then UmGen = Min
 
    Mutacja = 0: BrakZmian = 0

    If Pokolenie > 1 Then
      If Min >= UmGen Then
        BrakZmian2 = BrakZmian2 + 1
      Else
        BrakZmian2 = 0
        UmGen = Min
        For k = 1 To ArkuszHeight
          BestPierwotny(k) = Pierwotny(k)
        Next
      End If
    End If
    frmWorkUM.BestUm.Caption = Format$(UmGen, "###0.00000")
    frmWorkUM.lblChangesG.Caption = Str$(BrakZmian2)
    If BrakZmian2 = Generation Then Exit Do
Loop

Unload frmWorkUM

 For k = 1 To ArkuszHeight
   Pierwotny(k) = BestPierwotny(k)
 Next

 For i = 1 To ArkuszHeight
   For j = 1 To ArkuszWidth
     DaneMaczka(i, j) = Dane2(Pierwotny(i), j)
   Next
   RecInfo(i) = Rec3Info(Pierwotny(i))
 Next

 boOblicz = ComputeMatrix(ArkuszHeight, ArkuszWidth)
 If Not boOblicz Then
   Exit Sub
 End If

End If 'koniec automatycznego porzdkowania
'------------------------------------------------------------
gAnaliza = 0 'flaga do analizy

Screen.MousePointer = vbHourglass
    
'powolanie nowego obiektu DiagPar i formy Diagram
Dim fIndex
fIndex = 0
fIndex = CFindFreeIndex()
gIndex = fIndex
DiagPar(fIndex).Height = ArkuszHeight
DiagPar(fIndex).Width = ArkuszWidth
ReDim DiagPar(fIndex).Distance(1 To ArkuszHeight, 1 To ArkuszHeight)
ReDim DiagPar(fIndex).Data(1 To ArkuszHeight, 1 To ArkuszWidth)
ReDim DiagPar(fIndex).Etykiety(1 To ArkuszWidth)
ReDim DiagPar(fIndex).RecInfo(1 To ArkuszHeight)
ReDim DiagPar(fIndex).Przedzial(1 To 4)
ReDim DiagPar(fIndex).Grupa(1 To ArkuszHeight, 1 To ArkuszHeight)
DiagPar(fIndex).DistanceType = DystansType
DiagPar(fIndex).RodzajDiagramu = RodzajDiagramu
DiagPar(fIndex).MatrixOnly = True

'zapis danych do wewnetrznej tablicy diagramu
'tu poprawic - po kazdym typie porzadkowania
'osobny zapis
'For i = 1 To ArkuszHeight
'  For j = 1 To ArkuszWidth
'    DiagPar(fIndex).Data(i, j) = DaneMaczka(i, j)
'  Next
'Next

If OrderType = 1 Then
 'zapis macierzy odleglosci do wewnetrznej tablicy diagramu
  For i = 1 To ArkuszHeight
    For j = 1 To ArkuszHeight
      DiagPar(fIndex).Distance(i, j) = MatPar(gIndex).Distance(i, j)
    Next
  Next
  'zapis nazw rekordw to tablicy wewnetrznej diagramu
  'tu wariant bez porzadkowania
  For i = 1 To ArkuszHeight
    DiagPar(fIndex).RecInfo(i) = MatPar(gIndex).RecInfo(i)
  Next
ElseIf OrderType = 2 Then
'zapis macierzy odleglosci do wewnetrznej tablicy diagramu
  For i = 1 To ArkuszHeight
    For j = 1 To ArkuszHeight
      DiagPar(fIndex).Distance(i, j) = MatPar(gIndex).Distance(Kolejka(i), j)
    Next
  Next
  'zapis nazw rekordw to tablicy wewnetrznej diagramu
  'tu wariant dla prostego porzadkowania
  For i = 1 To ArkuszHeight
    DiagPar(fIndex).RecInfo(i) = MatPar(gIndex).RecInfo(Kolejka(i))
  Next
ElseIf OrderType = 3 Then

ElseIf OrderType = 4 Then
End If

'zapis etykiet (nazw) cech do wewnetrznej tablicy diagramu
'For i = 1 To ArkuszWidth
'  DiagPar(fIndex).Etykiety(i) = Etykiety(i)
'Next

'zapis granic przedzialow do wewnetrznej tablicy diagramu
For i = 1 To 4
  DiagPar(fIndex).Przedzial(i) = Val(Przedzial(i))
Next

'zapis macierzy do okna
For i = 1 To ArkuszHeight
  For j = 1 To ArkuszHeight
    If DiagPar(fIndex).Distance(i, j) >= 0 And DiagPar(fIndex).Distance(i, j) < DiagPar(fIndex).Przedzial(1) Then
      DiagPar(fIndex).Grupa(i, j) = 5
    ElseIf DiagPar(fIndex).Distance(i, j) >= DiagPar(fIndex).Przedzial(1) And DiagPar(fIndex).Distance(i, j) < DiagPar(fIndex).Przedzial(2) Then
      DiagPar(fIndex).Grupa(i, j) = 4
    ElseIf DiagPar(fIndex).Distance(i, j) >= DiagPar(fIndex).Przedzial(2) And DiagPar(fIndex).Distance(i, j) < DiagPar(fIndex).Przedzial(3) Then
      DiagPar(fIndex).Grupa(i, j) = 3
    ElseIf DiagPar(fIndex).Distance(i, j) >= DiagPar(fIndex).Przedzial(3) And DiagPar(fIndex).Distance(i, j) < DiagPar(fIndex).Przedzial(4) Then
      DiagPar(fIndex).Grupa(i, j) = 2
    ElseIf DiagPar(fIndex).Distance(i, j) >= DiagPar(fIndex).Przedzial(4) Then
      DiagPar(fIndex).Grupa(i, j) = 1
    Else
      DiagPar(fIndex).Grupa(i, j) = 6
    End If
  Next
Next

Diagram(fIndex).Caption = "[DIAGRAM]: Untitled:" & fIndex
Diagram(fIndex).BottomText = frmMDI.ActiveForm.BottomText
Diagram(fIndex).Tag = CStr(fIndex)
Diagram(fIndex).Siatka.Cols = DiagPar(fIndex).Height + 2
Diagram(fIndex).Siatka.Rows = DiagPar(fIndex).Height + 1
Diagram(fIndex).Siatka.FontBold = False
If ArkuszHeight > 99 Then
  Diagram(fIndex).Siatka.FontSize = 7
Else
  Diagram(fIndex).Siatka.FontSize = 8
End If
    
Diagram(fIndex).Siatka.ColAlignment(1) = 0
For i = 2 To DiagPar(fIndex).Height
  Diagram(fIndex).Siatka.ColAlignment(i) = 2
Next

Diagram(fIndex).Siatka.Row = 0
For i = 2 To DiagPar(fIndex).Height + 1
  Diagram(fIndex).Siatka.Col = i
  Diagram(fIndex).Siatka.COLWIDTH(i) = 1.5 * Diagram(fIndex).picColor01.Width
  Diagram(fIndex).Siatka.RowHeight(0) = Diagram(fIndex).picColor01.Height
  Diagram(fIndex).Siatka.Text = LTrim$(RTrim$(Str$(i - 1)))
Next
    
Diagram(fIndex).Siatka.Col = 0
For i = 0 To DiagPar(fIndex).Height
  Diagram(fIndex).Siatka.Row = i
  Diagram(fIndex).Siatka.COLWIDTH(i) = 450
  Diagram(fIndex).Siatka.RowHeight(i) = Diagram(fIndex).picColor01.Height
Next

Diagram(fIndex).Siatka.Col = 0
For i = 1 To DiagPar(fIndex).Height
  Diagram(fIndex).Siatka.Row = i
  Diagram(fIndex).Siatka.COLWIDTH(i) = 1.5 * Diagram(fIndex).picColor01.Width
  Diagram(fIndex).Siatka.RowHeight(i) = Diagram(fIndex).picColor01.Height
  Diagram(fIndex).Siatka.Text = LTrim$(RTrim$(Str$(i)))
Next

Diagram(fIndex).Siatka.Col = 1
For i = 0 To DiagPar(fIndex).Height
  Diagram(fIndex).Siatka.Row = i
  Diagram(fIndex).Siatka.COLWIDTH(1) = 1800
  Diagram(fIndex).Siatka.RowHeight(i) = Diagram(fIndex).picColor01.Height
  If i = 0 Then Diagram(fIndex).Siatka.Text = "Name"
  If i >= 1 Then Diagram(fIndex).Siatka.Text = DiagPar(fIndex).RecInfo(i)
Next

For i = 1 To DiagPar(fIndex).Height
  For j = 2 To DiagPar(fIndex).Height + 1
    Diagram(fIndex).Siatka.Row = i
    Diagram(fIndex).Siatka.Col = j
    Diagram(fIndex).Siatka.COLWIDTH(j) = Diagram(fIndex).picColor01.Width
    Diagram(fIndex).Siatka.RowHeight(i) = Diagram(fIndex).picColor01.Height
    Select Case DiagPar(fIndex).Grupa(i, j - 1)
      Case 1
        Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picColor01.Picture
      Case 2
        If DiagPar(fIndex).RodzajDiagramu = 1 Then
          Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picColor02.Picture
        ElseIf DiagPar(fIndex).RodzajDiagramu = 2 Then
          Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picCircle02.Picture
        ElseIf DiagPar(fIndex).RodzajDiagramu = 3 Then
          Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picClassic02.Picture
        End If
      Case 3
        If DiagPar(fIndex).RodzajDiagramu = 1 Then
          Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picColor03.Picture
        ElseIf DiagPar(fIndex).RodzajDiagramu = 2 Then
          Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picCircle03.Picture
        ElseIf DiagPar(fIndex).RodzajDiagramu = 3 Then
          Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picClassic03.Picture
        End If
      Case 4
        If DiagPar(fIndex).RodzajDiagramu = 1 Then
          Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picColor04.Picture
        ElseIf DiagPar(fIndex).RodzajDiagramu = 2 Then
          Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picCircle04.Picture
        ElseIf DiagPar(fIndex).RodzajDiagramu = 3 Then
          Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picClassic04.Picture
        End If
      Case 5
        If DiagPar(fIndex).RodzajDiagramu = 1 Then
          Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picColor05.Picture
        ElseIf DiagPar(fIndex).RodzajDiagramu = 2 Then
          Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picCircle05.Picture
        ElseIf DiagPar(fIndex).RodzajDiagramu = 3 Then
          Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picClassic05.Picture
        End If
      Case 0
        Diagram(fIndex).Siatka.Picture = Diagram(fIndex).picColor06.Picture
    End Select
  Next
Next

'------------

CState(fIndex).Dirty = True
Diagram(fIndex).WindowState = 0
'Diagram(fIndex).Width = 0.95 * Screen.Width
'Diagram(fIndex).Height = 0.8 * Screen.Height
'Diagram(fIndex).Left = 0
'Diagram(fIndex).Top = 0
Diagram(fIndex).Show

' reset mouse pointer
Screen.MousePointer = 0
End Sub

Public Sub DeleteVar()
If gAnaliza = 1 Then
  Beep
  Exit Sub
End If

frmDeleteVar.Show vbModal

End Sub

Public Sub EditVar()
If gAnaliza = 1 Then
   Beep
   Exit Sub
End If
    
frmVar.Show vbModal

End Sub

Sub SortSngAsc(ByRef Tablica() As Single)
Dim Elements As Long, Limit As Long
Dim Pomocnik As Single, i As Long
Dim swapmade As Long, interval As Long

Elements = UBound(Tablica) - LBound(Tablica)
If LBound(Tablica) = 0 Then Elements = Elements + 1
interval = Elements \ 2
   Do While interval > 0
      Limit = Elements - interval
      Do
         swapmade = 0
         For i = 1 To Limit
            If Tablica(i) > Tablica(i + interval) Then
               Pomocnik = Tablica(i)
               Tablica(i) = Tablica(i + interval)
               Tablica(i + interval) = Pomocnik
               swapmade = i
            End If
         Next i
         Limit = swapmade - interval
      Loop While swapmade
      interval = interval \ 2
   Loop
End Sub
