Attribute VB_Name = "modWMF"
Option Explicit

Const PS_DOT = 2
Const PS_SOLID = 0
Const RGN_AND = 1
Const RGN_COPY = 5
Const RGN_OR = 2
Const RGN_XOR = 3
Const RGN_DIFF = 4
Const HS_DIAGCROSS = 5
Const DT_CENTER = &H1
Const DT_LEFT = &H2 'sprawdzic czy to tak ma byc

'used with fnWeight
Const FW_DONTCARE = 0
Const FW_THIN = 100
Const FW_EXTRALIGHT = 200
Const FW_LIGHT = 300
Const FW_NORMAL = 400
Const FW_MEDIUM = 500
Const FW_SEMIBOLD = 600
Const FW_BOLD = 700
Const FW_EXTRABOLD = 800
Const FW_HEAVY = 900
Const FW_BLACK = FW_HEAVY
Const FW_DEMIBOLD = FW_SEMIBOLD
Const FW_REGULAR = FW_NORMAL
Const FW_ULTRABOLD = FW_EXTRABOLD
Const FW_ULTRALIGHT = FW_EXTRALIGHT
'used with fdwCharSet
Const ANSI_CHARSET = 0
Const DEFAULT_CHARSET = 1
Const SYMBOL_CHARSET = 2
Const SHIFTJIS_CHARSET = 128
Const HANGEUL_CHARSET = 129
Const CHINESEBIG5_CHARSET = 136
Const OEM_CHARSET = 255
'used with fdwOutputPrecision
Const OUT_CHARACTER_PRECIS = 2
Const OUT_DEFAULT_PRECIS = 0
Const OUT_DEVICE_PRECIS = 5
'used with fdwClipPrecision
Const CLIP_DEFAULT_PRECIS = 0
Const CLIP_CHARACTER_PRECIS = 1
Const CLIP_STROKE_PRECIS = 2
'used with fdwQuality
Const DEFAULT_QUALITY = 0
Const DRAFT_QUALITY = 1
Const PROOF_QUALITY = 2
'used with fdwPitchAndFamily
Const DEFAULT_PITCH = 0
Const FIXED_PITCH = 1
Const VARIABLE_PITCH = 2
'used with SetBkMode
Const OPAQUE = 2
Const TRANSPARENT = 1

Const LOGPIXELSY = 90
Const COLOR_WINDOW = 5

Const FORMAT_MESSAGE_ALLOCATE_BUFFER = &H100
Const FORMAT_MESSAGE_FROM_SYSTEM = &H1000
Const LANG_NEUTRAL = &H0
Const SUBLANG_DEFAULT = &H1

Private Type RECTL
   Left As Integer
   Top As Integer
   Right As Integer
   Bottom As Integer
End Type

Public Type RECT
   Left As Long
   Top As Long
   Right As Long
   Bottom As Long
End Type

Private Type POINTAPI
   x As Long
   y As Long
End Type

'Aldus Pleaceable Metafile Header
Private Type APMFILEHEADER
   key As Long
   hMF As Integer
   bbox As RECTL
   inch As Integer
   Reserved As Long
   checksum As Integer
End Type

'Private Const LF_FACESIZE = 32
'Private Type LOGFONT
'    lfHeight As Long
'    lfWidth As Long
'    lfEscapement As Long
'    lfOrientation As Long
'    lfWeight As Long
'    lfItalic As Byte
'    lfUnderline As Byte
'    lfStrikeOut As Byte
'    lfCharSet As Byte
'    lfOutPrecision As Byte
'    lfClipPrecision As Byte
'    lfQuality As Byte
'    lfPitchAndFamily As Byte
'    lfFaceName(LF_FACESIZE) As Byte
'End Type

'Aldus Pleaceable Metafile Constant
Const APMHEADER_KEY As Long = &H9AC6CDD7

'WMF file functions
Public Declare Function CreateMetaFile Lib "gdi32" Alias "CreateMetaFileA" (ByVal lpString As String) As Long
Public Declare Function CloseMetaFile Lib "gdi32" (ByVal hMF As Long) As Long
Public Declare Function DeleteMetaFile Lib "gdi32" (ByVal hMF As Long) As Long

'Draw functions
Public Declare Function LineTo Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long) As Long
Public Declare Function MoveToEx Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long, lpPoint As POINTAPI) As Long
Public Declare Function Ellipse Lib "gdi32" (ByVal hDC As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Public Declare Function TextOut Lib "gdi32" Alias "TextOutA" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long, ByVal lpString As String, ByVal nCount As Long) As Long
Public Declare Function SelectObject Lib "gdi32" (ByVal hDC As Long, ByVal hObject As Long) As Long
Public Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Public Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Public Declare Function FillRect Lib "user32" (ByVal hDC As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Public Declare Function CreateFont Lib "gdi32" Alias "CreateFontA" (ByVal nHeight As Long, ByVal nWidth As Long, ByVal nEscapement As Long, ByVal nOrientation As Long, ByVal fnWeight As Long, ByVal fdwItalic As Boolean, ByVal fdwUnderline As Boolean, ByVal fdwStrikeOut As Boolean, ByVal fdwCharSet As Long, ByVal fdwOutputPrecision As Long, ByVal fdwClipPrecision As Long, ByVal fdwQuality As Long, ByVal fdwPitchAndFamily As Long, ByVal lpszFace As String) As Long
Public Declare Function GetDeviceCaps Lib "gdi32" (ByVal hDC As Long, ByVal nIndex As Long) As Long
Public Declare Function Rectangle Lib "gdi32" (ByVal hDC As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Public Declare Function CreateHatchBrush Lib "gdi32" (ByVal nIndex As Long, ByVal crColor As Long) As Long
Public Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long
Public Declare Function DrawText Lib "user32" Alias "DrawTextA" (ByVal hDC As Long, ByVal lpStr As String, ByVal nCount As Long, lpRect As RECT, ByVal wFormat As Long) As Long
Public Declare Function SetRect Lib "user32" (lpRect As RECT, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long

'EMF file functions
Public Declare Function CreateEnhMetaFile Lib "gdi32" Alias "CreateEnhMetaFileA" (ByVal hdcRef As Long, ByVal lpFileName As String, lpRect As RECT, ByVal lpDescription As String) As Long
Public Declare Function CloseEnhMetaFile Lib "gdi32" (ByVal hDC As Long) As Long
Public Declare Function DeleteEnhMetaFile Lib "gdi32" (ByVal hemf As Long) As Long

'Other API
Public Declare Function MulDiv Lib "kernel32" (ByVal nNumber As Long, ByVal nNumerator As Long, ByVal nDenominator As Long) As Long
Public Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Public Declare Function GetLastError Lib "kernel32" () As Long
Public Declare Sub SetLastError Lib "kernel32" (ByVal dwErrCode As Long)
Public Declare Function FormatMessage Lib "kernel32" Alias "FormatMessageA" (ByVal dwFlags As Long, lpSource As Any, ByVal dwMessageId As Long, ByVal dwLanguageId As Long, ByVal lpBuffer As String, ByVal nSize As Long, Arguments As Long) As Long

'Non documented functions
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (pDst As Any, pSrc As Any, ByVal ByteLen As Long)


Public Function SavePlaceableMetafile(ByRef tname As String, ByRef strFileName As String, ByRef BRect As RECT)
Dim APMH As APMFILEHEADER
Dim nSize As Long
Dim lpvData() As Byte
Dim i As Long
Dim F As Integer

'MsgBox Str(CInt(BRect.Right)) & " x " & Str(CInt(BRect.Bottom))

With APMH
'--------------------------------------------------
'Define Aldus Placeable Header
'--------------------------------------------------
   .key = APMHEADER_KEY
   .hMF = 0
   .bbox.Left = CInt(BRect.Left)
   .bbox.Top = CInt(BRect.Top)
   .bbox.Right = CInt(BRect.Right)
   .bbox.Bottom = CInt(BRect.Bottom)
   .inch = 1000
   .Reserved = 0
   .checksum = CalcAPMCheckSum(APMH)
      
   nSize = FileLen(tname) 'Get length of the WMF file
   ReDim lpvData(nSize) As Byte 'Redimension the buffer size
      
   F = FreeFile
   Open tname For Binary As #F 'Store metafile to memory
      For i = 1 To nSize
         Get #F, i, lpvData(i - 1)
      Next i
   Close #F
     
   Kill tname  'Erase old WMF
   F = FreeFile
   Open strFileName For Binary As #F 'Create new placeable metafile
      Put #F, 1, .key
      Put #F, 5, .hMF
      Put #F, 7, .bbox.Left
      Put #F, 9, .bbox.Top
      Put #F, 11, .bbox.Right
      Put #F, 13, .bbox.Bottom
      Put #F, 15, .inch
      Put #F, 17, .Reserved
      Put #F, 21, .checksum
      For i = 1 To nSize
         Put #F, 22 + i, lpvData(i - 1)
      Next i
   Close #F
End With
  
End Function

Private Function CalcAPMCheckSum(ampfh As APMFILEHEADER) As Integer
Dim x As Integer
Dim i As Integer
Dim Address As Long
'------------------------------------------------------
' Calculate checksum by XOR contents of the header file
'------------------------------------------------------
Address = VarPtr(ampfh)
For i = 0 To 9
   CopyMemory x, ByVal Address + (i * 2), 2
   If i = 0 Then
      CalcAPMCheckSum = x
   Else
      CalcAPMCheckSum = CalcAPMCheckSum Xor x
   End If
Next i

End Function

Public Sub Draw(ByRef hDDC As Long, ByRef r As RECT, intHeight As Integer, Grupa() As Integer, Rodzaj As Integer, RecInfo() As String, Opis() As String)
Dim OldPoint As POINTAPI
Dim i As Long, k As Long, j As Long
Dim strString As String
Dim hFFBrush As Long
Dim PozycjaX As Long
Dim PozycjaY As Long
Dim intPromien(5) As Long
Dim Promien As Long
Dim intKolor(5) As Long
Dim cnt As Long

intPromien(1) = 0
intPromien(2) = 20
intPromien(3) = 45
intPromien(4) = 65
intPromien(5) = 90

intKolor(1) = 255
intKolor(2) = 180
intKolor(3) = 120
intKolor(4) = 60
intKolor(5) = 0

k = 140

'Dim hRPen As Long
'hRPen = CreatePen(PS_SOLID, 5, vbBlue)
'DeleteObject SelectObject(hDDC, hRPen)
'DeleteObject hRPen

With r
   .Top = 0
   .Left = 0
   .Bottom = k + (intHeight * k) + 200 + 5 * k + 100
   .Right = k + (5 * k) + (intHeight * k)
End With

DeleteObject SelectObject(hDDC, CreateMyFont(45, cnt))

'Rysuj diagram

'1 kolumna-numery
For i = 1 To intHeight + 1 'DiagPar(Index).Height + 1
   Meta_Line hDDC, 0, k * (i - 1), (5 * k) + intHeight * k, k * (i - 1)
   If i > 1 Then
      TextOut hDDC, 0 + 25, CLng(0 + (k * (i - 1)) + 10), LTrim$(CStr(i - 1)), Len(LTrim$(CStr(i - 1)))
   End If
Next

'pionowa po pierwszej kolumnie (z numerami)
Meta_Line hDDC, k, 0, k, (intHeight + 1) * k
'pionowa z lewej
Meta_Line hDDC, 0, 0, 0, (intHeight + 1) * k
'pozioma na dole
Meta_Line hDDC, 0, (intHeight + 1) * k, 5 * k + intHeight * k, (intHeight + 1) * k
'pionowa z prawej
Meta_Line hDDC, 5 * k + intHeight * k, 0, 5 * k + intHeight * k, (intHeight + 1) * k

'1 wiersz-numery
For i = 1 To intHeight 'DiagPar(Index).Height
   Meta_Line hDDC, (5 * k) + (i - 1) * k, 0, (5 * k) + (i - 1) * k, (intHeight + 1) * k
   TextOut hDDC, ((5 * k) + (i - 1) * k) + 25, 0 + 10, LTrim$(Str$(i)), Len(LTrim$(Str$(i)))
Next

'2 kolumna-etykiety
For i = 1 To intHeight + 1 'DiagPar(Index).Height + 1
   'Bitmapa(fIndex).Bmp.Line (k, 0 + (k * (i - 1)))-(k + (4 * k), 0 + (k * i)), , B
   'Rectangle hDDC, k, 0 + (k * (i - 1)), k + (4 * k), 0 + (k * i)
   Meta_Line hDDC, k, k * (i - 1), k + (4 * k), k * (i - 1)
   If i > 1 Then
      TextOut hDDC, k + 25, 0 + (k * (i - 1)) + 10, Left$(RecInfo(i - 1), 12), Left$(Len(RecInfo(i - 1)), 12)
   Else
      TextOut hDDC, k + 25, 0 + (k * (i - 1)) + 10, "Name", Len("Name")
   End If
Next

'symbole
For i = 1 To intHeight 'DiagPar(Index).Height
   For j = 1 To intHeight 'DiagPar(Index).Height
      Promien = intPromien(Grupa(i, j)) 'DiagPar(Index).Grupa(i, j))
      Select Case Rodzaj
         Case 1 ' DiagPar(Index).RodzajDiagramu = 1 Then
            If intKolor(Grupa(i, j)) <> 255 Then
            'If k > 100 Then
            'Bitmapa(fIndex).Bmp.Line ((5 * k) + (i - 1) * k, k + (k * (j - 1)))-((5 * k) + (i * k), k + (k * j)), RGB(intKolor(Grupa(i, j)), intKolor(Grupa(i, j)), intKolor(Grupa(i, j))), BF
            'End If
            End If
            'If k > 100 Then
            '  Bitmapa(fIndex).Bmp.Line ((5 * k) + (i - 1) * k, k + (k * (j - 1)))-((5 * k) + (i * k), k + (k * j)), , B
            'End If
    
         Case 2
      'If Kolor <> 255 Then
        'Bitmapa(fIndex).Bmp.FillStyle = 0
        'If k > 100 Then
          'Bitmapa(fIndex).Bmp.Circle (((5 * k) + (i - 1) * k) + (0.5 * k), (k + (k * (j - 1))) + (0.5 * k)), Promien, , , , sAspect
          hFFBrush = CreateSolidBrush(vbBlack)
          SelectObject hDDC, hFFBrush
          Meta_Circle hDDC, ((5 * k) + (i - 1) * k) + (0.5 * k), (k + (k * (j - 1))) + (0.5 * k), Promien
          DeleteObject hFFBrush
        'End If
        'Bitmapa(fIndex).Bmp.FillStyle = 1
      'End If
      'If k > 100 Then
      '  Bitmapa(fIndex).Bmp.Line ((5 * k) + (i - 1) * k, k + (k * (j - 1)))-((5 * k) + (i * k), k + (k * j)), , B
      'End If
    
    Case 3
      'If Kolor <> 255 Then
      '  If k > 100 Then
      '    lokX = Int(((5 * k) + (i - 1) * k) + (0.5 * k))
      '    lokY = Int((k + (k * (j - 1))) + (0.5 * k))
      '    BmpPic fIndex, lokX, lokY, Int(k * 0.7), DiagPar(Index).Grupa(i, j)
      '  End If
      'End If
    'End If
    'If DiagPar(Index).Grupa(i, j) = 0 Then
    '  If k > 100 Then
    '    Bitmapa(fIndex).Bmp.CurrentX = (5 * k) + (i - 1) * k + 25
    '  End If
    '  Bitmapa(fIndex).Bmp.CurrentY = k + (k * (i - 1)) + 25
    '  Bitmapa(fIndex).Bmp.Print "?"
    End Select
  Next
Next

'ramka dla diagramow klasycznych - w ktorych brak ramek dla pojedynczych komorek
'If DiagPar(Index).RodzajDiagramu = 3 Then
'  Bitmapa(fIndex).Bmp.FillStyle = 1
'  Bitmapa(fIndex).Bmp.Line (0, 0)-(5 * k + DiagPar(Index).Height * k, (DiagPar(Index).Height + 1) * k), , B
'End If

'legenda
PozycjaX = 50
PozycjaY = k * (intHeight + 1) + 200

For i = 1 To 5
  Select Case Rodzaj
    Case 1
    Case 2
      Promien = intPromien(6 - i)
      hFFBrush = CreateSolidBrush(vbBlack)
      SelectObject hDDC, hFFBrush
      Meta_Circle hDDC, PozycjaX + (k / 2), PozycjaY + (i - 1) * k, Promien
      'top
      Meta_Line hDDC, PozycjaX, PozycjaY + ((i - 1) * k + k / 2), PozycjaX + k, PozycjaY + ((i - 1) * k + k / 2)
      'bottom
      Meta_Line hDDC, PozycjaX, PozycjaY + ((i - 1) * k) - (k / 2), PozycjaX + k, PozycjaY + ((i - 1) * k) - (k / 2)
      'left
      Meta_Line hDDC, PozycjaX, PozycjaY + ((i - 1) * k) - (k / 2), PozycjaX, PozycjaY + ((i - 1) * k) + (k / 2)
      'right
      Meta_Line hDDC, PozycjaX + k, PozycjaY + ((i - 1) * k) - (k / 2), PozycjaX + k, PozycjaY + ((i - 1) * k) + (k / 2)
      DeleteObject hFFBrush
      TextOut hDDC, PozycjaX + 1.5 * k, PozycjaY + (i - 1) * k - (k / 4), Opis(i), Len(Opis(i))
    Case 3
  End Select
Next
  
'For i = 1 To 5
'  If DiagPar(Index).RodzajDiagramu = 2 Then
'    Promien = intPromien(6 - i)
'    Bitmapa(fIndex).Bmp.FillStyle = 0
'    Bitmapa(fIndex).Bmp.Circle (intSymbolX(i) + CInt(k / 2), intSymbolY(i) + CInt(k / 2)), Promien, QBColor(0), , , sAspect
 '   Bitmapa(fIndex).Bmp.FillStyle = 1
'    Bitmapa(fIndex).Bmp.Line (intSymbolX(i), intSymbolY(i))-(intSymbolX(i) + k, intSymbolY(i) + k), , B
'    Bitmapa(fIndex).Bmp.CurrentX = intSymbolX(i) + k + 150 'PozycjaX + (i - 1) * odstep * (k + 50) + k
'    Bitmapa(fIndex).Bmp.CurrentY = intSymbolY(i) + (CInt(k / 3)) 'pozycja tekstu opisu pionowo
'    Bitmapa(fIndex).Bmp.Print Opis(i)
'  ElseIf DiagPar(Index).RodzajDiagramu = 1 Then
'    Bitmapa(fIndex).Bmp.FillStyle = 0
'    Bitmapa(fIndex).Bmp.Line (intSymbolX(i), intSymbolY(i))-(intSymbolX(i) + k, intSymbolY(i) + k), RGB(intKolor(i), intKolor(i), intKolor(i)), BF
'    Bitmapa(fIndex).Bmp.FillStyle = 1
'    Bitmapa(fIndex).Bmp.Line (intSymbolX(i), intSymbolY(i))-(intSymbolX(i) + k, intSymbolY(i) + k), , B
'    Bitmapa(fIndex).Bmp.CurrentX = intSymbolX(i) + k + 150 'PozycjaX + (i - 1) * k + odstep  '* (k + 50) + k
'    Bitmapa(fIndex).Bmp.CurrentY = intSymbolY(i) + (CInt(k / 3)) 'pozycja tekstu opisu pionowo
'    Bitmapa(fIndex).Bmp.Print Opis(i)
'  ElseIf DiagPar(Index).RodzajDiagramu = 3 Then
'    BmpPic fIndex, intSymbolX(i) + CInt(k / 2), intSymbolY(i) + CInt(k / 2), Int(k * 0.7), CInt(i)
'    Bitmapa(fIndex).Bmp.Line (intSymbolX(i), intSymbolY(i))-(intSymbolX(i) + k, intSymbolY(i) + k), , B
'    Bitmapa(fIndex).Bmp.CurrentX = intSymbolX(i) + k + 150
'    Bitmapa(fIndex).Bmp.CurrentY = intSymbolY(i) + (CInt(k / 3)) 'pozycja tekstu opisu pionowo
'    Bitmapa(fIndex).Bmp.Print Opis(i)
'  End If
'Next
End Sub

Public Sub Save_WMF(strFile As String, intSizeOfDiagram As Integer, Grupa() As Integer, RecInfo() As String, sPrzedzial() As Single, intTypDistance As Integer, intTypDiagram As Integer)

Dim hMDC As Long
Dim hMeta As Long
Dim rct As RECT
Dim Opis(5) As String
Dim strTempFile As String

strTempFile = "c:\temp.wmf"

If intTypDistance = 1 Then
  Opis(1) = "0 - " & Format$(sPrzedzial(1), "#0.00#")
  Opis(2) = Format$(sPrzedzial(1), "#0.00#") & " - " & Format$(sPrzedzial(2), "#0.00#")
  Opis(3) = Format$(sPrzedzial(2), "#0.00#") & " - " & Format$(sPrzedzial(3), "#0.00#")
  Opis(4) = Format$(sPrzedzial(3), "#0.00#") & " - " & Format$(sPrzedzial(4), "#0.00#")
  Opis(5) = ">= " & Format$(sPrzedzial(4), "#0.00#")
End If

'Create Metafile Display Context
hMDC = CreateMetaFile(strTempFile)
If hMDC = 0 Then 'Error
  Dim Buffer As String
  'Create a string buffer
  Buffer = Space(200)
  'Format the message string
  FormatMessage FORMAT_MESSAGE_FROM_SYSTEM, ByVal 0&, GetLastError, LANG_NEUTRAL, Buffer, 200, ByVal 0&
  'Show the message
  MsgBox Buffer
End If
'Draw in the Metafile Display Context
Draw hMDC, rct, intSizeOfDiagram, Grupa(), intTypDiagram, RecInfo(), Opis()
'Close metafile and obtain the metafile handle
hMeta = CloseMetaFile(hMDC)
DeleteMetaFile hMeta
'Save as placeable metafile
SavePlaceableMetafile strTempFile, strFile, rct

End Sub

Public Sub Meta_Circle(ByVal hDC As Long, x As Long, y As Long, r As Long)
Ellipse hDC, x - CLng((r / 2)), y - CLng((r / 2)), x + CLng((r / 2)), y + CLng((r / 2))
End Sub

Public Sub Meta_Line(ByVal hDC As Long, X1 As Long, Y1 As Long, X2 As Long, Y2 As Long)
Dim OldPoint As POINTAPI
MoveToEx hDC, X1, Y1, OldPoint
LineTo hDC, X2, Y2
End Sub

Function CreateMyFont(nSize As Integer, nDegrees As Long) As Long
'Create a specified font
CreateMyFont = CreateFont(-MulDiv(nSize, GetDeviceCaps(GetDC(0), LOGPIXELSY), 72), 0, nDegrees * 10, 0, FW_NORMAL, False, False, False, DEFAULT_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, PROOF_QUALITY, DEFAULT_PITCH, "Courier New")
End Function

Public Sub Save_EMF(strFile As String, intSizeOfDiagram As Integer, Grupa() As Integer, RecInfo() As String, sPrzedzial() As Single, intTypDistance As Integer, intTypDiagram As Integer)

Dim hMDC As Long
Dim hMeta As Long
Dim rct As RECT
Dim Opis(5) As String
Dim strTempFile As String

strTempFile = "c:\temp.emf"

If intTypDistance = 1 Then
  Opis(1) = "0-" & CStr(sPrzedzial(1))
  Opis(2) = CStr(sPrzedzial(1)) & "-" & CStr(sPrzedzial(2))
  Opis(3) = CStr(sPrzedzial(2)) & "-" & CStr(sPrzedzial(3))
  Opis(4) = CStr(sPrzedzial(3)) & "-" & CStr(sPrzedzial(4))
  Opis(5) = ">= " & CStr(sPrzedzial(4))
End If

'Create Metafile Display Context
hMDC = CreateMetaFile(strTempFile)
If hMDC = 0 Then 'Error
  Dim Buffer As String
  'Create a string buffer
  Buffer = Space(200)
  'Format the message string
  FormatMessage FORMAT_MESSAGE_FROM_SYSTEM, ByVal 0&, GetLastError, LANG_NEUTRAL, Buffer, 200, ByVal 0&
  'Show the message
  MsgBox Buffer
End If
'Draw in the Metafile Display Context
Draw hMDC, rct, intSizeOfDiagram, Grupa(), intTypDiagram, RecInfo(), Opis()
'Close metafile and obtain the metafile handle
hMeta = CloseMetaFile(hMDC)
DeleteMetaFile hMeta
'Save as placeable metafile
SavePlaceableMetafile strTempFile, strFile, rct

End Sub

