Attribute VB_Name = "modOkna"
'******************************************************
'TEXTBAS.BAS: modul obslugi okienek aplikacji mdi
'******************************************************
Option Explicit

Type FormState
   Deleted As Integer
   Dirty As Integer
   Color As Long
End Type

Public FState() As FormState 'dane
'Public DState()  As FormState
Public MState()  As FormState 'macierze
Public CState()  As FormState 'diagramy?
Public BState()  As FormState 'bitmapy
Public document() As New frmNotePad
Public Macierz() As New frmMacierz
Public Diagram() As New frmDiagram
Public Bitmapa() As New frmBMP

Type DiagParType
   Height As Integer 'ilosc obiektw
   Width As Integer  'ilosc cech obiektu
   DistanceType As Integer
   Distance() As Single
   Data() As Single
   Etykiety() As String
   RecInfo() As String
   Przedzial() As Single
   RodzajDiagramu As Integer
   Grupa() As Integer
   Par_P As Integer
   Par_R As Integer
   MatrixOnly As Boolean
   DataRecNA() As Boolean
End Type

Public DiagPar() As DiagParType

Type MatParType
   RecInfo() As String
   Distance() As String
   Height As Integer
   FileName As String
End Type

Public MatPar() As MatParType

Type ImportMatrixType
   Comma As Integer          '1 srednik, 2 przecinek, 3 tabulator
   MatrixType As Integer     '1 distance, 2 similarity
   FirstCol As Boolean       'True - pierwszy wiersz zawiera nazwy rekordw
   FileName As String        'nazwa pliku z danymi do importu
   Precision As Integer      'zaokraglenie do ...
End Type

Global ImpMatrix As ImportMatrixType

Function BFindFreeIndex()
Dim i As Integer
Dim ArrayCount As Integer

ArrayCount = UBound(Bitmapa)

' Cycle throught the document array. If one of the
' documents has been deleted, then return that
' index.
For i = 1 To ArrayCount
   If BState(i).Deleted Then
      BFindFreeIndex = i
      BState(i).Deleted = False
      Exit Function
   End If
Next

' If none of the elements in the document array have
' been deleted, then increment the document and the
' state arrays by one and return the index to the
' new element.

ReDim Preserve Bitmapa(ArrayCount + 1)
ReDim Preserve BState(ArrayCount + 1)
BFindFreeIndex = UBound(Bitmapa)

End Function

Function CFindFreeIndex()
Dim i As Integer
Dim ArrayCount As Integer

ArrayCount = UBound(Diagram)

' Cycle throught the document array. If one of the
' documents has been deleted, then return that
' index.

For i = 1 To ArrayCount
   If CState(i).Deleted Then
      CFindFreeIndex = i
      CState(i).Deleted = False
      Exit Function
   End If
Next

' If none of the elements in the document array have
' been deleted, then increment the document and the
' state arrays by one and return the index to the
' new element.

ReDim Preserve Diagram(ArrayCount + 1)
ReDim Preserve CState(ArrayCount + 1)
ReDim Preserve DiagPar(ArrayCount + 1)
CFindFreeIndex = UBound(Diagram)

End Function

Function MFindFreeIndex()
Dim i As Integer
Dim ArrayCount As Integer

ArrayCount = UBound(Macierz)

' Cycle throught the document array. If one of the
' documents has been deleted, then return that
' index.
For i = 1 To ArrayCount
   If MState(i).Deleted Then
      MFindFreeIndex = i
      MState(i).Deleted = False
      Exit Function
   End If
Next

' If none of the elements in the document array have
' been deleted, then increment the document and the
' state arrays by one and return the index to the
' new element.

ReDim Preserve Macierz(ArrayCount + 1)
ReDim Preserve MState(ArrayCount + 1)
ReDim Preserve MatPar(ArrayCount + 1)
MFindFreeIndex = UBound(Macierz)

End Function

